/*
#$Id: kxyMgr.js,v 1.1.2.3 2009/08/20 09:19:30 cjj Exp $#
######################################################################

             IBM Confidential
             
             OCO Source Materials
             
             (C) Copyright IBM Corp. 2005-2007
             
             The source code for this program is not
             published or otherwise divested of its
             trade secrets, irrespective of what has
             been deposited with the U.S Government
             Copyright Office.

######################################################################
######################################################################
# Copyright 1999-2003, Candle Corporation, a California corporation.  
# All rights reserved. International copyright secured.
#
# This material is proprietary to Candle Corporation and is not to be
# reproduced, used, or disclosed except in accordance with program
# licenses or upon written authorization of Candle Corporation.
#
#######################################################################*/

var timeOut = 0;
window.onerror = errorHandler;
// install the global error-handler

function errorHandler(message, url, line)
{
   // message == text-based error description
   // url     == url which exhibited the script error
   // line    == the line number being executed when the error occurred

 // handle the error here

 // stop the event from bubbling up to the default window.onerror handler
 // (see the "For More Info" section for an article on event bubbling)

//    if (mainWin == null)
//    {
//        alert(message + "\n" + url + "\n" + "line: " + line);
//        return true;
//    }
   if(mainWin != null && mainWin.closed) return true;
   if (debug_On==true) ShowWindow('kxyJsErr','','500px','335px',[message,url,line,debug_On]);
   return true;
}

document.write('<link rel="stylesheet" type="text/css" href="kxystsh.css"/>');
document.write('<script language="javascript" src="kxyConfig.js"></script>');
document.write('<script language="javascript" src="kxydebug.js"></script>');
document.write('<script language="javascript" src="kxyConst.js"></script>');
document.write('<script language="javascript" src="kxyServr.js"></script>');
document.write('<script language="javascript" src="kxyXML.js"></script>');
document.write('<script defer language="javascript" src="kxyList.js"></script>');
document.write('<script language="javascript" src="kxyutil.js"></script>');
document.write('<script defer language="javascript" src="kxyModal.js"></script>');
document.write('<script language="javascript" src="kxyErrGn.js"></script>');
document.write('<script defer language="javascript" src="WebHelp/RoboHelp_CSH.js"></script>');

var unix=false;
var browser;	        // value of browser= ns or ie
var index = 0;	       // auxiliary variable to handle the tree		
var clientIndex = 0;  // auxiliary variable to handle the tree
var ActiveQmgr=null;      // has the name of the actual qmgr
var QType;	    // has the type of the actual qmgr= mq, jms, mqremote
var filterQType = "All";
var keepconn=false;
var DisplayedQ="all";
var Qopen=null;	// has the name of the queue open

var sync='';
var needcommit=false;
// settings for the message window

var displayHeader;  // has the value to display headers in the table of messages
var defaultHeader;
var maxMsg;
var current_peek=null; // needed for replace

var uid = ""; 	// it has the user id for this session
var env_type = "";
var pass;	// password of the userid
var newport=null;  // for unix
var oldport=null;  // for unix
var secondConn=0;  // for unix; specifies when the request is a create connection request
var createConn=0;

var windowOpen=0; // 1 if the debugging window is open
var debug_html="";
var readOnly=false;
var dlq=null;

var appliedFilters=[];  // filters that are currently applied.
var mbcsXML=[];
var xmlMQAttrib;
var mainWin;
var QNameFilter = "";
var QTypeFilter = "";
var bufferFull = false;

var param_1;
var param_2;
var param_3;
var param_4;
var param_5;
var param_6;
var param_7 = new Array();


//********************************************************************************
// URL REDIRECTION
//********************************************************************************

var redirection=0;  // 0=no redirection 1=redirection
var url_args;

function M_start()
{
if (debug_On==true) logEnter("M_start",null);

url_args=parseQueryString ();
if (((url_args[LOGIN]!=null)&&(url_args[PASS]==null))||((url_args[LOGIN]==null)&&(url_args[PASS]!=null)))
	M_alert(err_331);
else{
  if ((url_args[LOGIN]!=null)&&(url_args[PASS]!=null))
  {
   // do login
   result=M_login(url_args[LOGIN],url_args[PASS]);
   if (result!=null)
	redirection=1;	
  }
}  
if (debug_On==true) logExit("M_start",null);
}

function wait(delay){
string="M_start3();";
setTimeout(string,delay);
}

function M_start2()
{
   if (redirection==1) // no error
   {
	if ((url_args[QMGR]!=null))
	  if (url_args[TYPE]!=null)
	  {
		// load list
		wait(500); // it waits half a second and it calls load list --> this gives time to the frame to load, otherwise gives an error.
	  }else
		M_alert(err_332);
  }
}

function M_start3()
{
	result=setPointer(url_args[QMGR],url_args[TYPE],url_args[CLNAME],url_args[DISPLAY]);
	if (result!=null)	// no error
	  if (url_args[QUEUE]!=null)   // want to open msg window
	  {
		// load msg window
		option_open=openOptions(url_args,url_args[QUEUE]);
		result=M_openQueue(option_open);
	  }
}

function openOptions(url_args,queueName)
{if (debug_On==true) logEnter("openOptions",["urlArgs:"+url_args,"QueueName: "+queueName]);


  var params=[];
  params[0]=queueName;
  if (url_args[SYNC]!=undefined)
	params[1]='transactional';
  else
	params[1]='null';

 if (url_args[CONTEXT]!=undefined)
	params[2]=url_args[CONTEXT];
  else
	params[2]='null';

  if (url_args[LOGORD]!=undefined)
	params[3]=url_args[LOGORD];
  else
	params[3]='false';
  if (url_args[SEGMSG]!=undefined)
	params[4]=url_args[SEGMSG];
  else
	params[4]='false';

  if (url_args[RONLY]!=undefined)
  {
    if (url_args[RONLY]=='true')
    {
	params[5]='browse';
	params[6]='inquire';
	params[7]='null';
	params[8]='null';
     }
    else{
	params[5]='browse';
	params[6]='inquire';
	params[7]='get';
	params[8]='put';
    }
  }
  else{
	params[5]='browse';
	params[6]='inquire';
	params[7]='get';
	params[8]='put';
  }  

  if (url_args[IGNMDR]!=undefined)
  	params[9]=url_args[IGNMDR];
  else
	params[9]='false';
  if (url_args[DISPHEADER]!=undefined)
	params[10]=url_args[DISPHEADER];
  else
	params[10]='false';
  if (url_args[MAXMSG]!=undefined)
	params[11]=url_args[MAXMSG];
  else
	params[11]=20;
return params;
}
//********************************************************************************
// LOGIN
//********************************************************************************


function M_login(userid,password)
{if (debug_On==true) logEnter("login",["Userid: "+userid,"Password: ********"]);

  var xmlResult;
  var exception;

 if (userid!='')
 {
   browser=getBrowser();
   xmlResult=S_login(userid,password);
   uid=userid;
   pass=password;
   oldport=location.port;
   if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
    {
    	env_type = getTag("//Type",xmlResult);
    	if(env_type == null)
    		env_type = "All";
	eval("parent."+FRAME0+".location='kxyHe.htm'");
	if(env_type != null)
		eval("parent."+FRAME1+".location='kxylCol.htm?load=true;"+env_type+";'");
	else
		eval("parent."+FRAME1+".location='kxylCol.htm?load=true;'");
       	eval("parent."+FRAME2+".location='kxymainH.htm?disable=true;'");
       	
       	M_ListMBCS();

       	if(opener && !opener.closed && opener.uid != null)
       	{
       		opener.uid = uid;
       		opener.env_type = env_type;
       	}
		
	if (debug_On==true) logExit("login",null);
	return 0;
   }
    else
    if(xmlResult != null)
   {
	exception=getTag(EXPL,xmlResult,browser);
	M_alert(exception,getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
	frame2.resetCursor();
	if (debug_On==true) logExit("login",null);	
	return null;
   }

 }else
	M_alert(err_333);
	frame2.resetCursor();
	if (debug_On==true) logExit("login",null);
	return null;
}



function M_ListMBCS()
{
	if (debug_On==true) logEnter("M_ListMBCS",null);
	var xmlResult=S_ListMBCS();

	if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
	{
		for(var i=0; i < count("//CCSID",xmlResult); i++)
		{
			if(browser == "NS")
			{
				var n = i+1;
				mbcsXML[mbcsXML.length] = getTag("//CCSID["+n+"]",xmlResult);
			}
			else
				mbcsXML[mbcsXML.length] = getTag("//CCSID["+i+"]",xmlResult);
		}
	}
	if (debug_On==true) logExit("M_ListMBCS",null);
}



function M_HoldTimer(cancel)
{
	  var xmlResult=S_HoldTimer(cancel);
	  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)!="Success")
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
}


//********************************************************************************
// LOGOUT
//********************************************************************************


function M_logout()
{
  if(unix)
  	initializeLogout();
  else
  {
	  var xmlResult=S_logout();
	  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
	  {
		initializeLogout();
	  }else
	  if(xmlResult != null)
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
  }
}

function M_logoff()
{
  if(unix)
  	initializeLogout();
  else
  {
	  var xmlResult=S_logout();
	  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
	  {
		initializeLogout();
	  }
  }
}


function initializeVariables()
{
	setHandle(null);
	setConnid(-2);
	setBackConnid(-2);
	
	// Initialize the following for the next session.
	index = 0;	       
	clientIndex = 0; 
	newport = null; 
	ActiveQmgr=null;      
	DisplayedQ="all";
	Qopen=null;
	QType = TYPEMQ;
	sync='';
	current_peek=null; 
	readOnly=false;
	appliedFilters=[];  
	mbcsXML=[];
	QNameFilter = "";
	QTypeFilter = "";
	queueAdmin = "Yes";

	if(debugwin!=null)
	{
	    debugwin.close();
	    debugwin = null;
	}
	if (win!=null)
		win.close();
}


function initializeLogout()
{
	timeOut = 0;
	eval("parent."+FRAME0+".location='kxyblank.htm'");
	eval("parent."+FRAME1+".location='kxyblank.htm?load=true;'");
       	eval("parent."+FRAME2+".location='kxylogH.htm'");
       	initializeVariables();
}


function initializeTimeOut()
{
	timeOut = 2;
	eval("parent."+FRAME0+".location='kxyblank.htm'");
	if(env_type != null)
		eval("parent."+FRAME1+".location='kxylCol.htm?load=true;"+env_type+";'");
	else
		eval("parent."+FRAME1+".location='kxylCol.htm?load=true;'");
       	eval("parent."+FRAME2+".location='kxymainH.htm'");
       	initializeVariables();
}



//********************************************************************************
// OPTIONS
//********************************************************************************

function M_displayOptions()
{
 var optwin = ShowWindow('kxyopt','','325px','250px',[debug_On]);

}

//********************************************************************************
//*********************					**************************
//********************* 	TREE FUNCTIONS		**************************
//*********************					**************************
//********************************************************************************


//********************************************************************************
// DISPLAY TREE
//********************************************************************************
function M_listResources()
{
   var xmlResult=S_listResources(TYPEMQ);
   if(xmlResult != null && getTag(RETURNCODE, xmlResult) == "Success")
   {
	return xmlResult;
   }
 else
 {
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser)); 
  return null;
 }
}


//********************************************************************************
// Display JMS 
//********************************************************************************

function M_displayJMS()
{
if (debug_On==true) logEnter("M_displayJMS",null);
   xml_jms=S_listResources(TYPEJMS);
   if(xml_jms != null && getTag(RETURNCODE, xml_jms) == "Success")
   	frame1.expandJMS(xml_jms,index);
   else
   if(xml_jms != null)
	M_alert(getTag(EXPL,xml_jms,browser),getTag(EXCEPTION,xml_jms,browser),getTag(CCODE,xml_jms,browser),getTag(RCODE,xml_jms,browser)); 
   index=0;
if (debug_On==true) logExit("M_displayJMS",null);
}


//********************************************************************************
// Add new JMS
//********************************************************************************

function M_addNewJMS(params)
{
if (debug_On==true) logEnter("M_addNewJMS",params);
  var xmlResult=S_addNewJMS(params);
  index=1;
  if (xmlResult != null && getTag(RETURNCODE, xmlResult) == "Success")
  {
	globalProfile=getGlobalProfile(handle);
	M_displayJMS(index);
  }
  else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser)); 
if (debug_On==true) logExit("M_addNewJMS",null);
}

//********************************************************************************
// Remove JMS connection
//********************************************************************************

function M_removeJMS(params)
{
if (debug_On==true) logEnter("M_removeJMS",params);
  xmlResult=S_removeJMS(params);
  index=1; 
  if (xmlResult != null && getTag(RETURNCODE, xmlResult) == "Success")
  {
	globalProfile=getGlobalProfile(handle);
	M_displayJMS();
  }
  else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser)); 
if (debug_On==true) logExit("M_removeJMS",null);
}

//********************************************************************************
// Update JMS connection
//********************************************************************************
function M_updateJMS(params)
{
if (debug_On==true) logEnter("M_updateJMS",params);
  xmlResult=S_updateJMS(params);
  index=1;
  if (xmlResult != null && getTag(RETURNCODE, xmlResult) == "Success")
  {
	globalProfile=getGlobalProfile(handle);
	M_displayJMS();
  }
  else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_updateJMS",null);
}


//********************************************************************************
// Display Client Connection
//********************************************************************************

function M_clientConnection()
{
if (debug_On==true) logEnter("M_clientConnection",null);
   xml_clientConnections=S_getClientConnections();
   if(xml_clientConnections != null)
   {
   	frame1.expandClients(xml_clientConnections,clientIndex);
   	
   }
   clientIndex=0;
if (debug_On==true) logExit("M_clientConnection",null);
}


//********************************************************************************
// Add new Client Connection
//********************************************************************************

function M_addNewClientConnection(params)
{
if (debug_On==true) logEnter("M_addNewClientConnection",params);
  xmlResult=S_addNewClientConnection(params);
  clientIndex=1;
  if (getTag(RETURNCODE, xmlResult) == "Success")
  {
	globalProfile=getGlobalProfile(handle);
	M_clientConnection();
  }
  else
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_addNewClientConnection",null);
}

//********************************************************************************
// Remove ClientConnection connection
//********************************************************************************

function M_removeClientConnection(params)
{
if (debug_On==true) logEnter("M_removeClientConnection",params);
  xmlResult=S_removeClient(params);
  clientIndex=1;
  if (getTag(RETURNCODE, xmlResult) == "Success")
  {
	globalProfile=getGlobalProfile(handle);
	M_clientConnection();
  }
  else
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));

if (debug_On==true) logExit("M_removeClientConnection",null);
}

//********************************************************************************
// Update ClientConnection connection
//********************************************************************************
function M_updateClientConnection(params)
{
if (debug_On==true) logEnter("M_updateClientConnection",params);
  xmlResult=S_updateClient(params);
  clientIndex=1;
  if (getTag(RETURNCODE, xmlResult) == "Success")
  {
	globalProfile=getGlobalProfile(handle);
	M_clientConnection();
  }
  else
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));

 if (debug_On==true) logExit("M_updateClientConnection",null);
}


function setPointer(name,type,typeq,display,qname,clientPro)
{	
	param_1 = name;
	param_2 = type;
	param_3 = typeq;
	param_4 = display;
	param_5 = qname;
	
	if(type == TYPEMQ)
	{
		param_7 = clientPro;
		var tmp = frame2.frame3.document.QTypeForm.qsel;
		for(var q = 0; q <= 4; q++)
		{
			if(tmp[q].checked)
			{
				param_6 = tmp[q].value;
				break;
			}
		}
	}
	else
	{
		var tmp = frame2.frame3.document.QTypeJMSForm.qsel;
		for(var q = 0; q <= 2; q++)
		{
			if(tmp[q].checked)
			{
				param_6 = tmp[q].value;
				break;
			}
		}
	}
	
//	if (frame1.document.all) 
//	for (var i=0;i < frame1.document.all.length; i++) 
//		frame1.document.all(i).style.cursor = 'wait'; 
//	if (frame2.frame3.document.all) 
//	for (var i=0;i < frame2.frame3.document.all.length; i++) 
//		frame2.frame3.document.all(i).style.cursor = 'wait'; 
		
	setTimeout("M_displayQs()", 1);
}



function resetPointer()
{
//	if (frame1.document.all) 
//	for (var i=0;i < frame1.document.all.length; i++) 
//		frame1.document.all(i).style.cursor = 'auto'; 
//	if (frame2.frame3.document.all) 
//	for (var i=0;i < frame2.frame3.document.all.length; i++) 
//		frame2.frame3.document.all(i).style.cursor = 'auto'; 
}



function setPointerFilterQ(type,qname, q_type)
{
	if(ActiveQmgr == null)
		M_alert(err_326);
	else
	if(QType == q_type)
	{
			param_1 = type;
			param_2 = qname;

			if (frame1.document.all) 
			for (var i=0;i < frame1.document.all.length; i++) 
				frame1.document.all(i).style.cursor = 'wait'; 
			//if (frame2.frame3.document.all) 
			//for (var i=0;i < frame2.frame3.document.all.length; i++) 
				//frame2.frame3.document.all(i).style.cursor = 'wait'; 

			if(param_2 != null)
				setTimeout("M_filterQ()", 1);
			else
				setTimeout("M_filterQName()", 1);
	}
}



function resetPointerFilterQ()
{
	if (frame1.document.all) 
	for (var i=0;i < frame1.document.all.length; i++) 
		frame1.document.all(i).style.cursor = 'auto'; 
//	if (frame2.frame3.document.all) 
//	for (var i=0;i < frame2.frame3.document.all.length; i++) 
//		frame2.frame3.document.all(i).style.cursor = 'auto'; 
}



function setPointerTableGoTo(cursor,depthM)
{
	param_1 = cursor;
	param_2 = depthM;
	
	document.body.style.cursor = 'wait';
	
	setTimeout("M_goto()", 1);
}



function setPointerTableNav(mode,depthM)
{
	param_1 = mode;
	param_2 = depthM;
	
	hideNavImages();
	document.body.style.cursor = 'wait';
	
	setTimeout("M_nav()", 1);
}


function setPointerPaste(mode)
{
	if (debug_On==true) logEnter("setPointerPaste",null);
	param_1 = mode;

	document.body.style.cursor = 'wait';
	document.getElementById('buttonId').style.cursor = 'wait';
	
	setTimeout("M_paste()", 1);
	if (debug_On==true) logExit("setPointerPaste",null);
}



function setPointerTableRefresh(xmlResult,CloseFindWin)
{
	if (debug_On==true) logEnter("setPointerTableRefresh",null);
	param_1 = xmlResult;
	param_2 = CloseFindWin;
	
	document.body.style.cursor = 'wait';
	document.getElementById('buttonId').style.cursor = 'wait';
		
	setTimeout("M_refresh()", 1);
	if (debug_On==true) logExit("setPointerTableRefresh",null);
}

function resetPointerTable()
{
	document.body.style.cursor = 'auto';
	document.getElementById('buttonId').style.cursor = 'auto';
}



function M_displayQs()
{
	M_displayListQ(param_1,param_2,param_3,param_4,param_5,param_6, param_7)
}

//********************************************************************************
//**********************				**************************
//**********************	LIST FUNCTIONS		**************************
//**********************				**************************
//********************************************************************************

var xml_list;


function M_displayListQ(name,type,typeq,display,Qname,filterType, clientPro)
{
if(windowClose == 0)
{
    var funcin = new Date();

if (debug_On==true) logEnter("M_displayListQ",["Name: "+name,"Type: "+type,"Type Queue: "+typeq,"Display: "+display,"QName:"+Qname]);
var stime = new Date();

Qname=frame2.frame3.document.getElementById("qname").value;

if (ActiveQmgr!=null)
		frame2.frame3.document.getElementById('Queue').innerHTML ="";

ActiveQmgr=name;
QType=type;

var html;

if (display!=null)
	DisplayedQ=display;


if (keepconn==false)
	if (type==TYPEMQ)
	{
		xmlResult=S_createConnection(name,TYPEMQ,typeq, clientPro);
		if(queueAdmin == "No")
		{
			frame2.document.getElementById('createMenu').className = 'disabledOutMenu';
			frame2.document.getElementById('refreshMenu').className = 'disabledOutMenu';
			frame2.frame3.document.getElementById('clearMenu').className = 'disabledOutMenu';
			frame2.frame3.document.getElementById('deleteMenu').className = 'disabledOutMenu';
		}
		else
		{
			frame2.document.getElementById('createMenu').className = 'outMenu';
			frame2.document.getElementById('refreshMenu').className = 'outMenu';
			frame2.frame3.document.getElementById('clearMenu').className = 'outMenu';
			frame2.frame3.document.getElementById('deleteMenu').className = 'outMenu';
		}
	}else
	{
		xmlResult=S_createConnection(name,TYPEJMS);
		frame2.document.getElementById('refreshMenu').className = 'disabledOutMenu';
	}

var etime = new Date();
debugTime("displayList.createConnection",(etime.getTime() - stime.getTime()));
if (xmlResult != null && getTag(RETURNCODE,xmlResult)=="Success")
{
stime = new Date();
// Filter now occurs client side, so we always need the full list of q's
	if (Qname)
		//checkReturn=M_listQueues(filterType,Qname);
		checkReturn=M_listQueues("all",Qname);
	else
		//checkReturn=M_listQueues(filterType);
		checkReturn=M_listQueues("all");
etime = new Date();
debugTime("displayList.listQueues",(etime.getTime() - stime.getTime()));
	
	if(checkReturn == 0)
	{
stime = new Date();
		var dest = frame2.frame3.document.getElementById('Queue');
		generateList(dest,xml_list,ActiveQmgr,type);
etime = new Date();
debugTime("displayList.generateList",(etime.getTime() - stime.getTime()));
		showFilterByType(type);
		resetPointer();
var rest = new Date();
debugTime("resetPointer",(rest.getTime() - etime.getTime()));
		if (debug_On==true) logExit("M_displayListQ",null);
var funcout = new Date();
debugTime("displayList.totalTime",(funcout.getTime() - funcin.getTime()));
		return 0;
	}
	resetPointer();
	return;
	// enable functions in menu
}else
  if(xmlResult != null){
	resetPointer();
	newport=getTag("//Body/NewPort",xmlResult);
 	if (newport!=null)
	{
		unix=true;
		if (connid!=-2)			// if there is other connection open -> close it
		{
			xml_close=XML_getXMLClose(handle,connid);
			xmlResultClose=sendServer(xml_close,url+"/RPC2");
			
			setHandle(originalHandle);
			originalHandle = null;
			connid=-2;
			/*if (xmlResultClose != null && getTag(RETURNCODE,xmlResultClose,browser)=="Success")
				connid=-2;
			else
			if(xmlResultClose != null)
			{
				M_alert(getTag(EXPL,xmlResultClose,browser),getTag(EXCEPTION,xmlResultClose,browser),getTag(CCODE,xmlResultClose,browser),getTag(RCODE,xmlResultClose,browser));
				if (debug_On==true) logExit("M_displayListQ",null);				
				return;

			}*/

			//xmlResult=M_logout();	// I close the session for that connection

			/*if (getTag(RETURNCODE,xmlResult,browser)!="Success")
			{
				M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
				return 0;
			}else*/
				
		}		
		
		M_displayListQ(name,type,typeq,display,Qname);
		secondConn=1;		
	}
	else
	{
		exception=getTag(EXPL,xmlResult,browser);
		M_alert(exception,getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
		ActiveQmgr = null;
		//resetPointer();
		if (debug_On==true) logExit("M_displayListQ",null);
		//xmlResult=M_logout();
		return null;
	}
   }
resetPointer();
if (debug_On==true) logExit("M_displayListQ",null);
}
}

function M_filterQName(qname)
{
var qname = param_1;

if (debug_On==true) logEnter("M_filterQName",["Queue Name: "+qname]);
if (ActiveQmgr!=null)
{
checkReturn=M_listQueues(DisplayedQ,qname);
if(checkReturn == 0){
    var dest = frame2.frame3.document.getElementById('Queue');
	generateList(dest, xml_list,ActiveQmgr,QType);
	showFilterByType(QType);
	resetPointerFilterQ();
	if (debug_On==true) logExit("M_filterQName",null);
	return 0;
 }
}else M_alert(err_326);
resetPointerFilterQ();
if (debug_On==true) logExit("M_filterQName",null);
}

function M_listQueues(type,qname)
{
if (debug_On==true) logEnter("M_listQueues",["Type:"+type,"Queue Name:"+qname]);
if(qname != null)
	QNameFilter = qname;

	if(type != "all")
	{
		if(QType == TYPEMQ && type != "local" && type != "remote" && type != "alias" && type != "model")
			type = "all";
		if(QType != TYPEMQ && type != "persistent" && type != "temporary")
			type = "all";
	}
	
	QTypeFilter = type;	
	xml_list=S_listQueues(type,qname);
	
	if (xml_list != null && getTag(RETURNCODE, xml_list) == "Success")
	{
		if(QType == TYPEMQ)
		{
			var count_q = count("//QueueList/Queue",xml_list);
			xmlMQAttrib = M_DisplayQueue([qname],["QUEUE","CURDEPTH","TYPE"],type,count_q);
		}
		if (debug_On==true) logExit("M_listQueues",null);
		return 0;
	}
	else
	if(xml_list != null)
	   {
		exception=getTag(EXPL,xml_list);
		M_alert(exception,getTag(EXCEPTION,xml_list,browser),getTag(CCODE,xml_list),getTag(RCODE,xml_list));
		//add by lidongq
		var useLocalQueueCache = frame2.frame3.document.getElementById('useLocalCache');
		useLocalQueueCache.checked = false;
		var disabledList = ['hideempty','hidesystem'];
		for(var d=0;d<disabledList.length;d++){
			var elementCheckBox = frame2.frame3.document.getElementById(disabledList[d]);
			elementCheckBox.checked = false;
			elementCheckBox.disabled = true;	
		}
		frame2.frame3.hideEmpty = 0;
		frame2.frame3.hideSystem = 0;
		//end lidongq
		if (debug_On==true) logExit("M_listQueues",["return:-1"]);
		return -1;
		
	   }
if (debug_On==true) logExit("M_listQueues",null);
}


function M_RefreshQueues(sortBy)
{
     var funcin = new Date();
if (debug_On==true) logEnter("M_RefreshQueues",null);
if (ActiveQmgr!=null)
{
   if(QType == TYPEMQ)
   {
       //var xml_list = S_RefreshQueues(QNameFilter, QTypeFilter, sortBy);
       // force full refresh on f5
	   //lidongq
	   var qname1 = frame2.frame3.document.getElementById('qname').value;	   
	   var useLocalQueueCache = frame2.frame3.document.getElementById('useLocalCache');
	   useLocalQueueCache.checked = false;
		var disabledList = ['hideempty','hidesystem'];
		for(var d=0;d<disabledList.length;d++){
			var elementCheckBox = frame2.frame3.document.getElementById(disabledList[d]);
			elementCheckBox.checked = false;
			elementCheckBox.disabled = true;	
		}
		frame2.frame3.hideEmpty = 0;
		frame2.frame3.hideSystem = 0;			   
      // checkReturn = M_listQueues("all");      
       var type1 = frame2.frame3.document.getElementById('qsel').value ;       
       //alert('type1:' + type1);
       //alert('qname1:' + qname1);
       
       checkReturn=M_listQueues(type1,qname1);

       if (checkReturn == 0)
       {
           if (xml_list != null && getTag(RETURNCODE, xml_list) == "Success")
           {
           //    xmlMQAttrib = xml_list;
               var dest = frame2.frame3.document.getElementById('Queue');
               generateList(dest,xml_list,ActiveQmgr,QType);
           }
           else
               if(xml_list != null)
               {
                   exception=getTag(EXPL,xml_list);
                   M_alert(exception,getTag(EXCEPTION,xml_list,browser),getTag(CCODE,xml_list),getTag(RCODE,xml_list));
               }
       }
   }
}
else 
	M_alert(err_326);
if (debug_On==true) logExit("M_RefreshQueues",null);
var funcout = new Date();
debugTime("refreshQueues.totalTime",(funcout.getTime() - funcin.getTime()));

}



function M_showOpenQueueDialog(params){
if (debug_On==true) logEnter("M_showOpenQueueDialog",null);
	if (QType=="JMS")
		ShowWindow('kxyoQJMS','','720px','430px',params);
	else
	{
		if(browser == "NS"){
			var w = '695px';
		}else{
			var w = '850px';
		}    
		ShowWindow('kxyopnQ','',w,'500px',params);
		
	}
if (debug_On==true) logExit("M_showOpenQueueDialog",null);
}




function M_openCreateQueueDialog(type){
if (debug_On==true) logEnter("M_openCreateQueueDialog",["Type:"+type]);
	if(type == TYPEMQ){
		if(browser == "NS")
			ShowWindow('kxycrtQ','','420px','390px',[getBrowser()]);
		else
			ShowWindow('kxycrtQ','','430px','450px',[getBrowser()]);
	}
	else{
		ShowWindow('kxyCrQJM','','400px','200px',[getBrowser()]);
	}
if (debug_On==true) logExit("M_openCreateQueueDialog",null);
}

function M_createQueue(param)
{
if (debug_On==true) logEnter("M_createQueue",param);
	xmlResult=S_createQueue(param,QType); 
	if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
	{
		// refresh list
		keepconn=true;

		var tempID = parent.frame2.frame3.document.getElementById('listDiv');
		var valid = 0;
		var tempScroll = 0;
		if(tempID != null)
		{
			tempScroll = tempID.scrollTop;
			valid = 1;
		}
			
		M_displayListQ(ActiveQmgr,QType);
			
		if(valid == 1 && tempID != null)
		{
			parent.frame2.frame3.document.getElementById('listDiv').scrollTop = tempScroll;
		}
		keepconn=false;
				// display message
		M_alert(err_334);
	}
	else
	if(xmlResult != null)
	   {
		exception=getTag(EXPL,xmlResult);
		M_alert(exception,getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
	   }
if (debug_On==true)  logExit("M_createQueue",null);
}


function M_delete(name,purge)
{
if (debug_On==true) logEnter("M_delete",["Name:"+name,"Purge:"+purge]);
if (win!=null)
	win.close();

	xmlResult=S_delete(name,purge);
	if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
	{
		keepconn=true;	
		var tempID = parent.frame2.frame3.document.getElementById('listDiv');
		var valid = 1;
		var tempScroll = 0;
		
		if(tempID != null)
		{
			tempScroll = tempID.scrollTop;
			valid = 0;
		}
			
		M_displayListQ(ActiveQmgr,QType);
			
		if(valid == 1 && tempID != null)
			tempID.scrollTop = tempScroll;
		keepconn=false;
		M_alert(err_335);
		userProfile = getUserProfile(handle);
	}else
	if(xmlResult != null)
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));

if (debug_On==true)  logExit("M_delete",null);
}


function M_filterQ()
{
var type = param_1;
var qname = rtrim(ltrim(param_2));

if (debug_On==true) logEnter("M_filterQ",["Type:"+type,"Qname:"+qname]);
  
 if (ActiveQmgr!=null)
 {
     DisplayedQ = type;
     
     
     //lidongq	start
     var useLocalCacheElement = frame2.frame3.document.getElementById('useLocalCache');
     var enableLocalCache = useLocalCacheElement.checked ;
     if(enableLocalCache){
    	//lidongq end

         // queue name filtering is now handled client side
         
         //checkReturn=M_listQueues(type,qname);

         //if(checkReturn == 0){
             var dest = frame2.frame3.document.getElementById('Queue');
             generateList(dest, xml_list,ActiveQmgr,QType);
             resetPointerFilterQ();
             if (debug_On==true) logExit("M_filterQ",null);
             return 0;
        // }
    	 
    	 
     }else{
     
    	 checkReturn=M_listQueues(type,qname);
    	 if(checkReturn == 0){
             var dest = frame2.frame3.document.getElementById('Queue');
             generateList(dest, xml_list,ActiveQmgr,QType);
             resetPointerFilterQ();
             if (debug_On==true) logExit("M_filterQ",null);
             return 0;
         }
     
 
     }
   //lidongq end
 }
resetPointerFilterQ();
if (debug_On==true)  logExit("M_filterQ",null);
}


function M_ClearQueue(qname)
{
if (debug_On==true) logEnter("M_ClearQueue",["Qname:"+qname]);
 	xmlResult=S_ClearQueue(qname);
	if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
	{
		M_alert(err_346);
		if(frame2.frame3.document.getElementById('td_'+qname) != null)
			frame2.frame3.document.getElementById('td_'+qname).innerHTML = "<font class='MessageAttrib'><b>0</b></font>";
		
	}else
	if(xmlResult != null)
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true)  logExit("M_ClearQueue",null);
}


function M_DisplayQueue(qname,attrib,type,count)
{
if (debug_On==true) logEnter("M_DisplayQueue",["Qname:"+qname]);
 	xmlResult=S_DisplayQueue(qname,attrib,type,count);
 if (debug_On==true)  logExit("M_DisplayQueue",null);
	return xmlResult;


}


//********************************************************************************
//**********************				**************************
//**********************	Message Window		**************************
//**********************				**************************
//********************************************************************************

function M_openQueue(array_options)
{
	
if (debug_On==true) logEnter("M_openQueue",array_options);
var xmlResult=M_putQueueOptions(array_options);
if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
{
	var xmlResult=S_openQueue(array_options);
	if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
	{
		var params=[handle,connid,ActiveQmgr,QType,xmlResult,array_options[11],array_options[10],array_options[0],userProfile,globalProfile,array_options[1],uid,pass];
        	if ((array_options[7]=='null')&&(array_options[8]=='null'))
			params[13]=true; //readonly
		else 	
			params[13]=false;
		params[14]=[debug_r,debug_request,debug_resp,debug_p,debug_On,debug_html,debugwin,windowOpen];

		params[15]=appliedFilters;
		params[16]=newport;

		dlq=getTag("//Body/DLQ",xmlResult);
		if ((dlq!=null)&&(dlq=="Yes"))
			params[17]=dlq;
		else
			params[17]=null;

		params[18]=url;
		params[19]=mbcsXML;
		params[20]=array_options[array_options.length -1];
		params[21]=unix;
		params[22]=maxMessagesDisplay;
		params[23]=maxFieldSize;
		params[24]=maxFieldCount;
		params[25]=disableDeleteFile;
		params[26]=enableXMLUnload;
        //cjj
        params[27]=array_options[array_options.length - 3];
        //cjj end
		if (debugwin!=null)
			debugwin.close();
		// open window modal mode
	
		var width=window.screen.availWidth;
		var height=window.screen.availHeight;
		width=width + "px";
		if(browser == "NS")
			height=height + "px";
		else
			height=height - 20 + "px";
		ShowWindow('kxyMsgFr','',width,height,params);
		
		if (debug_On==true)  logExit("M_openQueue",["return:0"]);
		return 0;
	}else
	if(xmlResult != null){	 
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
		if (debug_On==true)  logExit("M_openQueue",["return:null"]);
		return null;
	}
}
else
if(xmlResult != null) 
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true)  logExit("M_openQueue",null);
}



function M_onload()
{
 hideNavImages();
if (debug_On==true) logEnter("M_onload",null);
  var params = parent.dialogArguments;				     // gets the parameters passed from the previous window
  browser=getBrowser();		  			    // sets the browser

//******************************************
// set environment
//******************************************

  handle=params[0];					   // sets the handle
  backconnid=params[1];
  ActiveQmgr=params[2];					  // sets the Active Qmgr
  QType=params[3];		  			 // sets Qtype
  connid=getTag(XPATHCONNID,params[4],browser);		// gets the connid for the connection
  maxMsg=params[5];
  displayHeader=params[6]  // display headers: true/false	// gets the option to display headers or not
  defaultHeader = params[6];
  Qopen=params[7];		 			// sets the name of the open queue
  userProfile=params[8];
  globalProfile=params[9]; 
  sync=params[10];
  url=params[18];
  mbcsXML = params[19];
  filterQType = params[20];
  uid=params[11];
  pass=params[12];

  if(QType != "JMS")
  	readOnly=params[13]; 
  debugging=params[14];
  appliedFilters=params[15];
  newport=params[16];
  dlq=params[17];
  unix = params[21];
  disableDeleteFile=params[25];
  enableXMLUnload=params[26];
  //cjj
  editMaxCount=params[27];
  //cjj end
  
  debug_r=debugging[0];
  debug_request=debugging[1];
  debug_resp=debugging[2];
  debug_p=debugging[3];
  debug_On=debugging[4];
  debug_html=debugging[5];
  debugwin=debugging[6];
  if (debugwin!=null)
  {
  	debugwin = null;
	M_debugger();
  }
  windowOpen=debugging[7];
  message_win = 1;
//*******************************************
// show table
//*******************************************

  var xml_msg=M_peek([maxMsg,"first","yes",''],true);    		   // gets the messages

  if (xml_msg!=null &&  getTag(RETURNCODE,xml_msg,browser)=="Success")
  {
  	current_peek = xml_msg;// display the table;
	refreshTable(xml_msg);	 
  }
  else{
     loadingMessage("Error retrieveing messages.");
     current_peek = null;
     document.getElementById('seqNumber').style.display="none";
     resetPointerTable();
  }
  
  fillQParam();
  document.getElementById('buttonId').style.cursor = 'auto';
  showNavImages();
if (debug_On==true) logExit("M_onload",null);
}


function refreshTable(xml_msg,closeFindWin,scroll)
{
 if (debug_On==true) logEnter("refreshTable",null);

 //var divM = document.getElementById('divM');
 messageDepth = 0;
 var tempScroll = document.getElementById('messagesDisplay').scrollTop;
 generateTable(xml_msg,displayHeader); 
 bufferFull = false;
 tableStatus();
 if(scroll != null && scroll == 1)
 	document.getElementById('messagesDisplay').scrollTop = 0;
 else
 	document.getElementById('messagesDisplay').scrollTop = tempScroll;

resetPointerTable();
if ((win)&&(closeFindWin==true))
	columnOff(1);
	
selectedColumn=null;
t_colName=null;
t_colId=null;
t_format=null;
t_kxyType=null;
t_index=null;
t_column = null;
found=null;
colSelected=0;
select_flag = "";
originVal = "";
if (debug_On==true) logExit("M_refreshTable",null);

//if(divM!=undefined)
//	divM.style.cursor='auto';
}


function M_colFilter(colname,mode)
{
if (debug_On==true) logEnter("M_colFilter",["ColName:"+colname,"Mode:"+mode]);
  var st=S_colFilter(colname,mode);
  if (st<0)
	M_alert("Error");
if (debug_On==true) logExit("M_colFilter",null);
}

function M_peek(params,apply)
{
if (debug_On==true) logEnter("M_peek",params);
var useFilterFlag = "no";
var Tag=['Count','Mode','UseFilter','Cursor'];

if ((appliedFilters.length!=0)&&(apply))
{
	var fi="";
	var fic="";
	var fih="";
	var fich="";
	var j=0;
	var k=0;
	var i=1;
	
	if (appliedFilters[0]!=0)
	{
		 for (i=1;i<=appliedFilters[0];i++)
			fi+="<Filter>"+appliedFilters[i]+"</Filter>";
		 params[params.length]=fi;
		 Tag[Tag.length]="RowDataFilter";
		 useFilterFlag = "yes";
	}

	if (appliedFilters[i]!=0)
	{
	 for (j=i+1;j<=i+parseInt(appliedFilters[i]);j++){

	 	if(appliedFilters[j] != undefined && appliedFilters[j] != 0)
			fic+="<Filter>"+appliedFilters[j]+"</Filter>";
	 }
	 params[params.length]=fic; 
	 Tag[Tag.length]="ColumnDataFilter";
	 useFilterFlag = "yes";
	}
	else
		j = i +1;
	

        if (appliedFilters[j]!=0)
	{
	 for (k=j+1;k<=j+parseInt(appliedFilters[j]);k++){
	 	if(appliedFilters[k] != undefined && appliedFilters[k] != 0)
			fih+="<Filter>"+appliedFilters[k]+"</Filter>";
	 }
	 params[params.length]=fih; 
	 Tag[Tag.length]="RowHeaderFilter";
	 useFilterFlag = "yes";
	}
	else
		k = j +1;
		
        if (appliedFilters[k]!=0)
	{
	 for (i=k+1;i<=k+parseInt(appliedFilters[k]);i++){
	 	if(appliedFilters[i] != undefined && appliedFilters[i] != 0)
			fich+="<Filter>"+appliedFilters[i]+"</Filter>";
	 }
	 params[params.length]=fich; 
	 Tag[Tag.length]="ColumnHeaderFilter";
	 useFilterFlag = "yes";
	}

}
params[2] = useFilterFlag;
	if (current_peek!=null) // this if was commented
	{
		var tempCount = count("//Response/Body/Message",current_peek) - 1;
		var path = "//Body/Message["+tempCount+"]/Header//RemainingMessageLength";
		remainLength=getXMLTag(path,current_peek);
 		if (browser=="NS")
		{
		    var nod=remainLength.iterateNext();
		    remainLength=nod;
		    if (!remainLength)	
			remainLength=null;
		  }
		if ((remainLength!=null)&&(getTag("//RemainingMessageLength",remainLength)!=0))
		{
			ci=getTag("//Body/Message["+tempCount+"]/Header//ConnId",current_peek);
			params=[params[0],params[1],params[2],ci];
			Tag[3]='ConnId';
		}

	}

   	xmlResult=S_peek(params,Tag);
	
	if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
	{
		current_peek = xmlResult;
		document.MessageForm.gotoM.value = "";
		if (debug_On==true) logExit("M_peek",null);
		return xmlResult;
	}else
	if(xmlResult != null)
	{
		if(getTag(RETURNCODE,xmlResult,browser) != null)
		{
			M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
			resetPointerTable();
			if (debug_On==true) logExit("M_peek",null);
			return null;
		}
		else
		{
			M_alert(err_278);
		}
	}
if (debug_On==true) logExit("M_peek",null);
}


function M_chooseFmt()
// opens the dialog window to choose a format to create a message
// pass the connid and handle
{
if (debug_On==true) logEnter("M_chooseFmt",null);       
	var XMLFmt = M_listAvailFmt();
  	var queueName = checkSpecialChars(getQueueName());
  	queueName = checkBackSlash(queueName);
  	
  	if(getQType() == TYPEMQ)
  		var XMLPATH = "//MQSeries/Backend[Name=\""+getActiveQmgr()+"\"]//Queues/Queue[Name = \""+queueName+"\"]/IgnoreMDR";
  	else
  		var XMLPATH = "//JMS/Backend[Name=\""+getActiveQmgr()+"\"]//Queues/Queue[Name = \""+queueName+"\"]/IgnoreMDR";
	var ignore_mdr = getTag(XMLPATH,userProfile);

	if(ignore_mdr == "true")
	{
		if(getQType() == TYPEMQ)
			ShowWindow('kxyCrtFr','','700px','650px',["raw_format","","","",getHandle(),getConnid(),getQType(),getBrowser(),0,"",getActiveQmgr(),getQueueName(),'',url,mbcsXML]);	
		else
			ShowWindow('kxyCrJMF','','700px','650px',["raw_format","","","",getHandle(),getConnid(),getQType(),getBrowser(),0,"",getActiveQmgr(),getQueueName(),'',url,mbcsXML]);	
	}
	else
		ShowWindow('kxyStFmt','','450px','450px',[XMLFmt,getBrowser(),url,getQType()]);

if (debug_On==true) logExit("M_chooseFmt",null);
}

function M_listAvailFmt(sysFmt)
{  
if (debug_On==true) logEnter("M_listAvailFmt",null);  
   var xmlResult=S_listAvailFmt(sysFmt);
   if (xmlResult!=null){
	if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
	{
		if (debug_On==true) logExit("M_listAvailFmt",null);
		return xmlResult;
	}else
	if(xmlResult != null)
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
    }else
	M_alert(err_345);
if (debug_On==true) logExit("M_listAvailFmt",null);
}

function M_createMsgW(fmt,updateFmt)
{
if (debug_On==true) logEnter("M_createMsgW",["Format:"+fmt,"Update MQMD Format:"+updateFmt]);
   var xmlResult=S_getMetaData(fmt);
   if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
   {
	// open the create message window with the fmt
	if(getQType() == TYPEMQ)
		ShowWindow('kxyCrtFr','','700px','650px',[fmt,xmlResult,"","",getHandle(),getConnid(),getQType(),getBrowser(),0,"",getActiveQmgr(),getQueueName(),updateFmt,url,mbcsXML]);
	else
		ShowWindow('kxyCrJMF','','700px','650px',[fmt,xmlResult,"","",getHandle(),getConnid(),getQType(),getBrowser(),0,"",getActiveQmgr(),getQueueName(),updateFmt,url,mbcsXML]);
   }else
   if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_createMsgW",null);
}



function M_createMsg(xml,fmt,kxyType,col,val)
{
	if (debug_On==true) logEnter("M_createMSg",["XMl:"+xml,"Format:"+fmt,"kxyType:"+kxyType,"Column:"+col,"Value:"+val]);
	xmlResult=S_createMess(xml,col,val);
	if (xmlResult != null)
	{
		var ccode =  getTag(CCODE,xmlResult,browser);

		if(getTag(RETURNCODE,xmlResult,browser)=="Success" || (ccode && ccode == "KXY_ERR_BUFFER_FULL"))
		{
			window.returnValue = xmlResult;
			window.close();
		}
		else
		{
			if (ccode && ccode==KXY_ERR_SESSION_CLOSED || ccode==KXY_ERR_IDLE || ccode==KXY_ERR_SECURITY)
			{
				if(ccode==KXY_ERR_SESSION_CLOSED || ccode==KXY_ERR_SECURITY)
				{
					timeOut = 2; 
					M_alert(err_352);
				}
				else
				{
					timeOut = 1;
					M_alert(err_342);
				}

				if(parent.frame0 != null)
				{
					if(ccode==KXY_ERR_SESSION_CLOSED || ccode==KXY_ERR_SECURITY)
						initializeLogout();
					else
						initializeTimeOut();
				}
				else
				{
					if (win!=null)
						win.close();	

					if (debugwin!=null)
						debugwin.close();

					window.close();
					windowClose = 1;	
				}

			}
			else
			{
				var alertMessage="";
				if (getTag(EXPL,xmlResult,browser)!=null)
					alertMessage += getTag(EXPL,xmlResult,browser);	
				if (getTag(EXCEPTION,xmlResult,browser)!=null)
					alertMessage += getTag(EXCEPTION,xmlResult,browser);
				if (ccode!=null)
					alertMessage += "<br/>Completion code- "+ccode;
				if (getTag(RCODE,xmlResult,browser)!=null)
					alertMessage += "<br/>Reason code- "+ getTag(RCODE,xmlResult,browser);
				if (alertMessage=="")
					alertMessage="error";

				displayAlert(alertMessage);
				showHeight = 410;
				document.getElementById('bodyEdit').style.height = "380";
				rowN= 13;
				if(document.XMLTreeForm.XMLEntry != null)
					document.XMLTreeForm.XMLEntry.rows = 13;
			}
		}
	}

if (debug_On==true) logExit("M_createMsg",null);
}



function M_RefreshMsg(xmlResult,closeFindWin)
// it refreshes the window of messages, if xmlResult is not specify refreshes with the messages from the server
// otherwise it refreshes with the messages passed as parameter.
{
if (debug_On==true) logEnter("M_refreshMsg",null);

  if (xmlResult==null)
  {
	  xmlResult=S_Buffer();
	  
  	  if(xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  	  	return xmlResult;
  	  else
  	  {
  	    	if(xmlResult != null)
  	    	{
  	    		loadingMessage("Error retrieveing messages.");
	   		if(getTag(RETURNCODE,xmlResult,browser) == null)
	   		{
	   			M_alert(err_278);
	   		}
			else
	  			M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
	  				resetPointerTable();
 			return null;	 
 		}
 	  }
  }
  else
  {
  	if(xmlResult != null)
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
 	loadingMessage("Error retrieveing messages.");
 	document.getElementById('seqNumber').style.display="none";
 	current_peek = null;
 	
	 	resetPointerTable();
 		return null;
  }
if (debug_On==true) logExit("M_refreshMsg",null);

}




function M_refresh(p1,p2)
// it refreshes the window of messages, if xmlResult is not specify refreshes with the messages from the server
// otherwise it refreshes with the messages passed as parameter.
{
//document.body.style.cursor = 'wait';//DCC			
if(p1)
	var xmlResult = param_1;
else
	var xmlResult = p1;
	
if(p2)	
	var closeFindWin = param_2;
else
	var closeFindWin = p2;

if ((needcommit==true)&&(sync=='transactional'))
	var ret=ShowWindow("kxycomit","",'450px','230px',["refresh"]);
else
	var ret = true;	
if(ret)
{
if (debug_On==true) logEnter("M_refresh",null);
var max;
if (win!=null)
	win.close();

var valid = 1;

if(rtrim(ltrim(document.MessageForm.depthM.value)).length == 0)
 	max = maxMsg;
else
{
 	max = document.MessageForm.depthM.value;
 	valid = validateM('', max);
 }
	  	
var startCount;
if(rtrim(ltrim(document.MessageForm.gotoM.value)).length == 0)
	startCount = beginSequence;
else
{
	startCount = document.MessageForm.gotoM.value;
	valid = validateM(startCount, '');
}
  	
if(valid == 1)
{
  loadingMessage("Table refreshing, please wait...");

  Sleep(this,500);
  this.NextStep=function()
  { 
	  //for(var a=0;a<100000;a++){}
	 
	  if (xmlResult==null)
	  {
	  	 xmlResult=M_peek([max,'','yes',startCount],true);
	  }
	
	  if ( xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
	  {
		refreshTable(xmlResult,closeFindWin);
		
		if(max != null)
			document.MessageForm.depthM.value = max;	
	  }else
	  {
	  	if(xmlResult != null)
				M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
		 	loadingMessage("Error retrieveing messages.");	
		 	document.getElementById('seqNumber').style.display="none";
		 	current_peek = null;
	 	
		 	resetPointerTable();//DCC
	  }
  
	}
}
}
//DCC resetPointerTable();
if (debug_On==true) logExit("M_refersh",null);
//document.body.style.cursor = 'auto';//DCC		
}

function M_closeQ(logout, flag)
{
if (debug_On==true) logEnter("M_closeQ",["Logout:"+logout]);
var return_value;

if (win!=null && confDlgOpen == 1)
{
	if(findReplFlag == 1)
		M_alert(err_271);
	else
		M_alert(err_272);
}
else
{
		
if(timeOut == 1 || timeOut == 2)
{
	if (logout!=null)
		return_value =["logout",debug_html,debug_request,debug_resp,debug_r,debug_p,debug_On,debugwin,windowOpen,timeOut]; // if we need to logout completely
	else
		return_value=["null",debug_html,debug_request,debug_resp,debug_r,debug_p,debug_On,debugwin,windowOpen,timeOut];	// if we are only closing the queue

	if(browser == "NS")
		window.parent.opener.actionAfterCloseDialog(return_value,"kxyMsgFr");
	else
		window.returnValue = return_value;
		
	window.parent.close();
	return;
}

var ret = "true";

if ((needcommit==true)&&(sync=='transactional'))
{
	ret = "repeat";
	while(ret == "repeat")
	{
		ret=ShowWindow("kxycomit","",'450px','230px',["logout", flag]);
	}
}
		
if(ret == "true")
{				
	  xmlResult=S_closeQ();
	  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
	  {
		if (debug_On==true) logExit("M_closeQ",null);
		appliedFilters=[];  
		setConnid(-2);	

		if (logout!=null)
			return_value =["logout",debug_html,debug_request,debug_resp,debug_r,debug_p,debug_On,debugwin,windowOpen,timeOut]; // if we need to logout completely
		else
			return_value=["null",debug_html,debug_request,debug_resp,debug_r,debug_p,debug_On,debugwin,windowOpen,timeOut];	// if we are only closing the queue

		if(browser == "NS")
			window.parent.opener.actionAfterCloseDialog(return_value,"kxyMsgFr");
		else
			window.returnValue = return_value;

		if (win!=null)
		{
			win.close();
			setInterval('closeq()', 500);
		}
		else
		if(debugwin!= null)
		{
				debugwin.close();
				setInterval('closeq()', 500);
		}
		else
			window.parent.close();
	  }else
	  {
	  	closeQueue = 0;
	  	if(xmlResult != null)
			M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
	  }

}
else
	closeQueue = 0;
}
if (debug_On==true) logExit("M_closeQ",null);
}

function M_closeQcont(docommit,logout)
// for netscape the continuation of the closeq.
{
	
  xmlResult=S_closeQ();
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	if (debug_On==true) logExit("M_closeQ",null);
	//appliedFilters=[];  
	setConnid(-2);	
	
	if (logout!=null)
		var return_value =["logout",debug_html,debug_request,debug_resp,debug_r,debug_p,debug_On,debugwin]; // if we need to logout completely
	else
		var return_value=["null",debug_html,debug_request,debug_resp,debug_r,debug_p,debug_On,debugwin];	// if we are only closing the queue

	if(browser == "NS")
		window.parent.opener.actionAfterCloseDialog(return_value,"kxyMsgFr");
	else
  		window.returnValue = return_value;


	if (win!=null)
		win.close();
	if (windowOpen==1){  // this is for the debugger, if it is open i need a delay to let the debugger pass all the information to the main window.
		debugwin.close();
		debugwin=null;
		tid = setInterval('closeq()', 2000);	
	}else
		window.parent.close();	

  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));

}

var tid;

function closeq()
{
   window.parent.close();
}



function M_deleteMsg(id)
{
if (debug_On==true) logEnter("M_deleteMsg",["Id:"+id]);
if(!readOnly){
 var ids=[-1];
 if ((id=="")||(id==null))
    ids=getSelectedMsg();

  if (ids.length!=0)
  {
    if ((id!="")&&(id!=null))
      xmlResult=S_deleteMsg([id]);
    else
      xmlResult=S_deleteMsg(ids);
    if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
    {
	needcommit=true;
 	var xmlResult2=M_RefreshMsg();
	pendingMessages(3, xmlResult2);
	M_alert("<font class='Attribute'><b>"+getTag("/Response/Header/Completion",xmlResult)+"</b></font> message(s) have been deleted.");
    }else
    if(xmlResult != null)
 	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
  }else
	M_alert(err_242);
}
else
	M_alert(err_208);

if (debug_On==true) logExit("M_deleteMsg",null);
}



function M_edit(id,msg)
{
if (debug_On==true) logEnter("M_edit",["Id:"+id]);
var valid = 1;
var selectedConids = getSelectedMsg();
if(id == '')
{
	if (countSelectedM>1)
	{
		M_alert(err_243);
		valid = 0;
	}
	if (countSelectedM==0)
	{
		M_alert(err_244);
		valid = 0;
	}
		
}
if(valid == 1)
{
   if (id == '')
   {
   	selectedConID = selectedConids[0];
   	selectedMessage=selectedMsgNos[0];
	if ((needcommit==true)&&(sync=='transactional'))
	{
		var temp = getTag("/Response/Body/Message["+selectedMessage+"]/Header/KXY/STATUS",current_peek);
		if (temp == "INS" || temp == "UPD")
		{
			valid = 0;
		}
	}
   }
   else{
   	selectedConID = id[0];
  }
  
 if(valid == 1)
  	openXMLTree(selectedMessage,selectedConID);
}
if (debug_On==true) logExit("M_edit",null);
}


function M_update(msg,kxyType,col,val)
{
if (debug_On==true) logEnter("M_update",["kxyType:"+kxyType,"Column:"+col,"Value:"+val]);
if (msg!=null)
{
  var xmlResult=S_update(msg,kxyType,col,val);

  if (xmlResult==null)  // there was an error forming the xml for the hexa values
  {
   M_alert(err_245);
   return null; 
  }
  if (xmlResult != null)
  {
  	var ccode =  getTag(CCODE,xmlResult,browser);
	  if(getTag(RETURNCODE,xmlResult,browser)=="Success" || (ccode && ccode == "KXY_ERR_BUFFER_FULL"))
	  {
			window.returnValue = xmlResult;
			window.close();
	  }
	  else
	  {
		if (ccode && ccode==KXY_ERR_SESSION_CLOSED || ccode==KXY_ERR_IDLE || ccode==KXY_ERR_SECURITY)
		{
			if(ccode==KXY_ERR_SESSION_CLOSED || ccode==KXY_ERR_SECURITY)
			{
				timeOut = 2;
				M_alert(err_352);
			}
			else
			{
				timeOut = 1;
				M_alert(err_342);
			}

			if(parent.frame0 != null)
			{
				if(ccode==KXY_ERR_SESSION_CLOSED || ccode==KXY_ERR_SECURITY)
					initializeLogout();
				else
					initializeTimeOut();
			}
			else
			{
				if (win!=null)
					win.close();	

				if (debugwin!=null)
					debugwin.close();

				window.close();
				windowClose = 1;	
			}

		}
		else
		if (ccode && ccode==KXY_ERR_DEL)
		{
			M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),ccode,getTag(RCODE,xmlResult,browser));
			var xmlResult2=M_RefreshMsg();
			pendingMessages(3, xmlResult2);	
			needcommit=true;
		}
		else
		{
			var alertMessage="";
			if (getTag(EXPL,xmlResult,browser)!=null)
				alertMessage += getTag(EXPL,xmlResult,browser);
			if (getTag(EXCEPTION,xmlResult,browser)!=null)
				alertMessage += getTag(EXCEPTION,xmlResult,browser);
			if (getTag(CCODE,xmlResult,browser)!=null)
				alertMessage += "<br/>Completion code- "+ getTag(CCODE,xmlResult,browser);
			if (getTag(RCODE,xmlResult,browser)!=null)
				alertMessage += "<br/>Reason code- "+ getTag(RCODE,xmlResult,browser);
			if (alertMessage=="")
				alertMessage="error";
				
			displayAlert(alertMessage);
			showHeight = 410;
			document.getElementById('bodyEdit').style.height = "380";
			rowN= 13;
			if(document.XMLTreeForm.XMLEntry != null)
				document.XMLTreeForm.XMLEntry.rows = 13;
			else
				checkForMDRXMLMessage(1);

		}
	}
	}
}else
	M_alert(err_247);
if (debug_On==true) logExit("M_update",null);
}




function M_copyMsg(id)
{
if (debug_On==true) logEnter("M_copyMsg",["Id:"+id]);
 var ids=[-1];
 if (id==null) 
   ids=getSelectedMsg();
  
  if (ids.length!=0)
  {
    if (id!=null)
      xmlResult=S_copyMsg(id);
    else
      xmlResult=S_copyMsg(ids);
    if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
    {
	//M_alert(err_248);
	M_alert("<font class='Attribute'><b>"+getTag("/Response/Header/Completion",xmlResult)+"</b></font> message(s) have been copied.");
    }else
    if(xmlResult != null)
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
  }else
	M_alert(err_249);
if (debug_On==true) logExit("M_copyMsg",null);
}

function M_cutMsg(id)
{
if (debug_On==true) logEnter("M_cutMsg",["Id:"+id]);
if(!readOnly){
 var ids=[-1];
 if (id==null) 
   ids=getSelectedMsg();
  
  if (ids.length!=0)
  {
    if (id!=null)
      xmlResult=S_cutMsg(id);
    else
      xmlResult=S_cutMsg(ids);
    if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
    {
	needcommit=true;
	var xmlResult2=M_RefreshMsg(); 
	pendingMessages(3, xmlResult2);
	M_alert("<font class='Attribute'><b>"+getTag("/Response/Header/Completion",xmlResult)+"</b></font> message(s) have been cut.");
    }else
    if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
  }else
  {
	M_alert(err_251);
   }
}
else
{
	M_alert(err_208);
}
if (debug_On==true) logExit("M_cutMsg",null);
}


function M_paste()
// mode: yes, no
{
var mode = param_1;
if (debug_On==true) logEnter("M_paste",["Mode:"+mode]);
if(!readOnly)
{
if(!bufferFull)
{
  var xml_msg;
  xmlResult=S_paste(mode);
  if (xmlResult != null)
  {
  	var ccode =  getTag(CCODE,xmlResult,browser);
  	if(getTag(RETURNCODE,xmlResult,browser)=="Success" || (ccode && ccode == "KXY_ERR_BUFFER_FULL"))
	  {
		needcommit=true;

		if (mode=='yes')
		{
			var max;
			if(rtrim(ltrim(document.MessageForm.depthM.value)).length == 0)
				max = maxMsg;
			else
				max = document.MessageForm.depthM.value;

			xml_msg=M_peek([max,'last','yes']);			
			setPointerTableRefresh(xml_msg);
		}else
		{
			if(ccode && ccode == "KXY_ERR_BUFFER_FULL")
				var temp = getTag("/Response/Body/PartialCompletion",xmlResult);
			else
				var temp = getTag("/Response/Header/Completion",xmlResult);
			
			var xmlResult2=M_RefreshMsg(); 
			pendingMessages(4,xmlResult2);
			M_alert("<font class='Attribute'><b>"+temp+"</b></font> message(s) have been pasted.");
		}
		if(ccode && ccode == "KXY_ERR_BUFFER_FULL")
		{
			M_alert(err_273);
			bufferFull = true;
		}
	  }else
	  {
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
		var tempCount = getTag("/Response/Body/PartialCompletion",xmlResult);
		if(tempCount)
		{
			if(tempCount > 0)
			{
				var xmlResult2=M_RefreshMsg(); 
				pendingMessages(4,xmlResult2);
			}
			M_alert("<font class='Attribute'><b>"+tempCount+"</b></font> message(s) have been pasted.");
		}
	  }
    }
}
else
	M_alert(err_273);
}
else
	M_alert(err_208);
resetPointerTable()
if (debug_On==true) logExit("M_paste",null);
}


function M_displayDelete()
// display window for delete
{
if (debug_On==true) logEnter("M_displayDelete",null);
   var ids = new Array();
   ids=getSelectedMsg();
   if(ids.length == 0)
   	M_alert(err_253);
   
   if(ids.length != 0){

	ShowWindow('kxydelMW','','470px','170px',['',getBrowser(),7]);
   }
   
if (debug_On==true) logExit("M_displayDelete",null);
}



function M_displayForward(id)
// display window for forward
{
if (debug_On==true) logEnter("M_displayForward",["Id:"+id]);
if(!readOnly){
   var params = new Array();
   var ids = new Array();
   if (id==null){ 
   	ids=getSelectedMsg();
   	if(ids.length == 0)
   		M_alert(err_254);
   }
   if(id!=null || ids.length != 0){

   var mgr=M_qmgr();
   if (mgr != null && getTag(RETURNCODE,mgr,browser)=="Success")
   {
	   var countMgr = count("//ResourceList/Resource",mgr);

	   params[0] = countMgr;
	   var index = 1;

	   for (i=0;i<countMgr;i++){
	   if(browser == "NS"){
		var p = i+1;
		params[index] = getTag("//ResourceList/Resource["+p+"]/Name",mgr);
	   }else
		params[index] = getTag("//ResourceList/Resource["+i+"]/Name",mgr);

	    index++;
	   }

	   params[index]=getBrowser();
	   params[params.length]=getQType();

	   if(QType == TYPEMQ)
		var widthW =  '510px';
	   else
		var widthW =  '530px';

	   if (QType == TYPEMQ)
		   ShowWindow('kxyFoDLQ',id,widthW,'390px',params);
	   else
		   ShowWindow('kxyForWn',id,widthW,'335px',params);
      }
      else
      if(mgr != null)
	   M_alert(getTag(EXPL,mgr,browser),getTag(EXCEPTION,mgr,browser),getTag(CCODE,mgr,browser),getTag(RCODE,mgr,browser));

   }
}
else
 	M_alert(err_208);
if (debug_On==true) logExit("M_displayForward",null);
}

function M_forward(qname,qmgr,id,strip,retry)
{
if (debug_On==true) logEnter("M_forward",["Qname:"+qname,"Qmgr:"+qmgr,"Id:"+id,"Strip:"+strip,"Retry:"+retry]);
  var ids=getSelectedMsg();
  
  if (ids.length!=0 || id != null)
 {
   if(id == null)
   	forwardID = ids;
   else{
   	forwardID = id;
  }
  }
  var xmlResult=S_forward(qname,qmgr,forwardID,strip,retry);

  if (getTag(RETURNCODE,xmlResult)=="Success")
  {
	needcommit=true;		
	var xmlResult2=M_RefreshMsg(); 
	pendingMessages(3, xmlResult2);
	
	var temp = "<font class='Attribute'><b>"+getTag("/Response/Header/Completion",xmlResult)+"</b></font> message(s) have been forwarded";
	if(qname == "null")
		temp += ".";
	else
		temp += " to "+ qname+".";
	M_alert(temp);
  }else{
	M_alert(getTag(EXCEPTION,xmlResult),getTag(EXPL,xmlResult),getTag(CCODE,xmlResult),getTag(RCODE,xmlResult));}
if (debug_On==true) logExit("M_forward",null);

}

function M_availFiles(common, fileFilter)
// returns an xml with the available files
{
if (debug_On==true) logEnter("M_availFiles",null); 

  var xmlResult=S_availFiles(common, fileFilter);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	if (debug_On==true) logExit("M_availFiles",null);
	return xmlResult;
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
  
if (debug_On==true) logExit("M_availFiles",null);
return null;
}

function M_load(file)
{
if (debug_On==true) logEnter("M_load","File:"+file);
if(!readOnly){
  var xmlResult=S_load(file);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	needcommit=true;
	setPointerTableRefresh(null);
	var msgCount = getTag("/Response/Header/Completion",xmlResult);
	if (msgCount == -1)
	{
		var deletedFile = "" + file;
		var startIndex = deletedFile.lastIndexOf("!") + 1;
		M_alert("File " + deletedFile.substring(startIndex, deletedFile.length - 1) + " was deleted.");
	}
	else
	{
		M_alert("<font class='Attribute'><b>"+getTag("/Response/Header/Completion",xmlResult)+"</b></font> message(s) have been loaded.");
	}
	
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
}
else
	M_alert(err_208);
if (debug_On==true) logExit("M_load",null);
}

function M_unload(file,append,all,deleteMessages,toXML,separate,header,split)
{
if (debug_On==true) logEnter("M_unload",["File:"+file,"Append:"+append,"All:"+all,"XML:"+toXML],"separate:"+separate, "header:"+header, "split:"+split);
var ids,xmlResult;

  if (all=='false')
  {
	ids=getSelectedMsg();
  	xmlResult=S_unload(file,append,ids,deleteMessages,toXML,separate,header,split);
  }else
	xmlResult=S_unload(file,append,'',deleteMessages,toXML,separate,header,split);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
  	if(deleteMessages == 'yes'){
		needcommit=true;
  		setPointerTableRefresh(null);
  		M_alert("<font class='Attribute'><b>"+getTag("/Response/Header/Completion",xmlResult)+"</b></font> message(s) have been unloaded and deleted from this queue.");
  	}
  	else
		//M_alert(err_257);
		M_alert("<font class='Attribute'><b>"+getTag("/Response/Header/Completion",xmlResult)+"</b></font> message(s) have been unloaded.");
	
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
	
if (debug_On==true) logExit("M_unload",null);
}

function M_nav()
// mode can be: fist, previous, next, last
{
	var mode = param_1;
	var depthM = param_2;
	if (debug_On==true) logEnter("M_nav",["Mode:"+mode],true);
	
	var xmlResult=M_peek([depthM,mode,'yes',''],true);
	
	colSelected=0;
	selectedColumn=null; 
	if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
	{ 		
		param_1 = t_colName;
		param_2 = t_format;
		param_3 = t_kxyType;
		param_4 = t_index;
		param_5 = t_column;
		
		refreshTable(xmlResult,'',1);

		if(win != null)
			setTimeout("chkColSel()", 1);
		
		
	}
	else
	{
		loadingMessage("Error retrieveing messages.");
		current_peek = null;
		resetPointerTable();
		document.getElementById('seqNumber').style.display="none";
	}

	showNavImages();
	
	if (debug_On==true) logExit("M_nav",null);
}



function M_goto()
{
	var cursor = param_1;
	var depthM = param_2;
	
	if ((needcommit==true)&&(sync=='transactional'))
		var ret=ShowWindow("kxycomit","",'450px','230px',["refresh"]);
	else
		var ret = true;	
	if(ret)
	{
		loadingMessage("Loading...");
		var startCount;
		if(rtrim(ltrim(cursor)).length == 0)
			startCount = beginSequence;
		else
			startCount = cursor;

		 var xmlResult=M_peek([depthM,'','yes',startCount],true);
		 if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
		 {
			param_1 = t_colName;
			param_2 = t_format;
			param_3 = t_kxyType;
			param_4 = t_index;
			param_5 = t_column;

			refreshTable(xmlResult);
			
			if(win != null)
				setTimeout("chkColSel()", 1);
		 }
		 else{
			loadingMessage("Error retrieveing messages.");
			current_peek = null;
			resetPointerTable();
			document.getElementById('seqNumber').style.display="none";
		 }
	}
	else
		resetPointerTable();
}



function M_setHexValue(field,value,id)
{
if (debug_On==true) logEnter("M_setHexValue",["Field:"+field,"Value:"+value,"ID:"+id]); 
  var xmlResult=S_setHexValue(field,value,id)
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	M_alert("Field has been updated with the new value.");
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_setHexValue",null);
}

function M_getHex(value,CCSID)
{

if (debug_On==true) logEnter("M_getHex",["Value:"+value,"CCSID:"+CCSID]);
  var xmlResult=S_getHex(value,CCSID)
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	aux=getTag(HEXVALUE,xmlResult,browser);
	if (debug_On==true) logExit("M_getHex",["return:"+aux]);
	return aux;
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_getHexV",null);
}


function M_getText(value,CCSID)
{
if (debug_On==true) logEnter("M_getText",["Value:"+value,"CCSID:"+CCSID]);
  var xmlResult=S_getText(value,CCSID)
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	var aux1=getTag(HEXVALUE,xmlResult,browser);
	var aux2 = getTag("//Type",xmlResult,browser);
	if (debug_On==true) logExit("M_getText",["return:"+aux]);
	return [aux1,aux2];
  }else
	return null;
if (debug_On==true) logExit("M_getText",null);
}


function M_getHexValue(field,id)
{
if (debug_On==true) logEnter("M_getHex",["Field:"+field,"Id:"+id]);
  var xmlResult=S_getHexValue(field,id)
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	aux=getTag(HEXVALUE,xmlResult,browser);
	if (debug_On==true) logExit("M_getHexValue",["return:"+aux]);
	return aux;
  }else
  {
	  if(xmlResult != null)
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
	  return null;
  }
if (debug_On==true) logExit("M_getHexValue",null);
}


//zhou parse unknownformat message
function M_ParseMsgAgain(field,id)
{
	if (debug_On==true) logEnter("M_ParseMsgAgain",["Field:"+field,"Id:"+id]);
  var xmlResult=S_ParseMsgAgain(field,id);
  //alert("M_ParseMsgAgain   "+xmlResult.text);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	aux=xmlResult;
	if (debug_On==true) logExit("M__ParseMsgAgain",["return:"+aux]);
	
	return aux;
  }else
  {
	  if(xmlResult != null)
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
	  return null;
  }
if (debug_On==true) logExit("M__ParseMsgAgain",null);
}

//zhou parse unknowningoreformat message
function M_ParseIngoreMsgAgain(field,id)
{
	if (debug_On==true) logEnter("M_ParseIngoreMsgAgain",["Field:"+field,"Id:"+id]);
  var xmlResult=S_ParseIngoreMsgAgain(field,id);
  //alert("M_ParseIngoreMsgAgain   "+xmlResult.text);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	aux=xmlResult;
	if (debug_On==true) logExit("M__ParseIngoreMsgAgain",["return:"+aux]);
	
	return aux;
  }else
  {
	  if(xmlResult != null)
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
	  return null;
  }
if (debug_On==true) logExit("M__ParseIngoreMsgAgain",null);
}

function M_commit(flag)
{
if (debug_On==true) logEnter("M_commit",null);
if (sync=='transactional')
{
  var xmlResult=S_commit();
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	needcommit=false;
	M_alert(err_258);
	if(flag == null || (flag != null && flag != "logout" && flag != "refresh"))
		M_refresh(null);
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
}else
	M_alert(err_259);
if (debug_On==true) logExit("M_commit",null);
}

function M_rollback(flag)
{
if (debug_On==true) logEnter("M_rollback",null);
if (sync=='transactional')
{
  var xmlResult=S_rollback();
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	needcommit=false;
	M_alert(err_260);
	if(flag == null || (flag != null && flag != "logout" && flag != "refresh"))
		M_refresh(null);
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
}else
	M_alert(err_261);
if (debug_On==true) logExit("M_rollback",null);
}


var win=null;


function M_displayFind()
{
if (debug_On==true) logEnter("M_displayFind",null);
if (win!=null)
{
	findFlag = false;
	win.focus();
	setTimeout('bringFocusFR()', 500);
	return;
}

  var col=getSelectedColName();
  var index=getSelectedColNo();
  if (col!=null){
     if (win!=null)
	win.close();
	 var kxyT=getSelectedTypekxy();
	var fmt=getSelectedFormat();
	
	document.getElementById('checkAll').checked = false;
	selectAll(document.getElementById('checkAll'));
		
	findReplFlag = 1;
	var tempCol = "";
	if(kxyT == "STANDALONE" && fmt != "Map" && fmt != "Stream")
		tempCol = t_column;
	
	dialogName = "kxyFind";

	win=window.open("kxyFind.htm?"+col+";"+getHandle()+";"+getConnid()+";"+url+";"+browser+";"+index+";"+kxyT+";"+fmt+";"+tempCol+";"+getActiveQmgr()+";"+getQueueName()+";"+selectedFmt+";"+selectedpFmt,'',"top=100,left=300,toolbar=no,location=no,status=no,menubar=no,scrollbars=no,resizable=no,width=500,height=275");
}
  else
	M_alert(err_262);
if (debug_On==true) logExit("M_displayFind",null);
}

function focusHandler()
{
	self.moveTo(0,0);
 	self.resizeTo(screen.availWidth,screen.availHeight);
    	self.focus();
}


var doitagain=false;
var confDlgOpen = 0;

function M_find(column,value,mode,index,kxyT,check,fmt)
{
  if (debug_On==true) logEnter("M_find",["Column:"+column,"Value:"+value,"Mode:"+mode]);
  var table;	
  
  var xmlResult=S_find(column,value,mode,kxyT,check,fmt,index);

  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	result=opener.selectFind(index,xmlResult,column,value,'','',fmt,kxyT);
	
	if (result==null)
	 if (mode != 'first')
	 {
		if (browser!="NS")
		{
			opener.confDlgOpen = 1;
			var doitagain=window.showModalDialog("kxyfinms.htm","Message","dialogWidth='450px';dialogHeight='200px';scroll=no;status=no;caption='no';status=no;menubar=no;resizable=no;titlebar='0';help='no'");		
			opener.confDlgOpen = 0;
		}
		else
		{
			var doitagain=ShowWindow("kxyfinms","",'450px','200px',["Message",browser,column,value,mode,index,kxyT,check,fmt]);
			return;
		}
		if (doitagain==true)
		{
			mss=opener.document.getElementById("messagesDisplay");
			if (mss)
			mss.scrollTop=0;
			
			//opener.colSelected=0;
			//opener.selectCol(opener.t_colName,opener.t_colId,opener.t_format,opener.t_kxyType,opener.t_index,1); // the 1 is to let the client to select the column
			xmlResult=M_find(column,value,'first',index,kxyT,check,fmt);
			doitagain=false;
		}
	}
	 else{
	 	opener.confDlgOpen = 1;
		M_alert("Cannot find <font class='Attribute'><b>"+value+"</font>.");
		opener.confDlgOpen = 0;
		found=null;
	}
	else
		found=xmlResult;
	if (win!=null)
		win.focus();
	
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
 	
return xmlResult;
if (debug_On==true) logExit("M_find",null);


}


function contFind(doitagain,column,value,mode,index,kxyT,check,fmt)
{
if (doitagain==true)
{
	mss=opener.document.getElementById("messagesDisplay");
	if (mss)
		mss.scrollTop=0;
		xmlResult=M_find(column,value,'first',index,kxyT,check,fmt);
		doitagain=false;
	}
}

var found=null;
var needtoUpdate=false;
function M_displayReplace()
{
if (debug_On==true) logEnter("M_displayReplace",null);
if (readOnly==true)
{
	M_alert("Queue has been open read only.");
	return;
}
if (win!=null)
{
	findFlag = false;
	win.focus();
	setTimeout('bringFocusFR()', 500);
	return;
}

  var col=getSelectedColName();
  var index=getSelectedColNo();
  if (col!=null){
	if (win!=null)
		win.close();
	var kxyT=getSelectedTypekxy();
	var fmt=getSelectedFormat();
	
	document.getElementById('checkAll').checked = false;
	selectAll(document.getElementById('checkAll'));
	
	findReplFlag = 2;
	var tempCol = "";
	if(kxyT == "STANDALONE" && fmt != "Map" && fmt != "Stream")
		tempCol = t_column;
	dialogName = "kxyRepl";

	win=window.open("kxyRepl.htm?"+col+";"+getHandle()+";"+getConnid()+";"+url+";"+browser+";"+index+";"+kxyT+";"+fmt+";"+tempCol+";"+getActiveQmgr()+";"+getQueueName()+";"+selectedFmt+";"+selectedpFmt,'',"top=100,left=300,toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,copyhistory=no,width=500,height=310");
}
  else
	M_alert(err_262);
if (debug_On==true) logExit("M_displayreplace",null);
}


function M_replace(column,value,newvalue,mode,index,kxyT,check,fmt)
{ 
if (debug_On==true) logEnter("M_replace",["Column:"+column,"Value:"+value,"New value:"+newvalue,"Mode:"+mode]);
var xmlResult;
var aux=null;
if(found != null)
{
	var node = getXMLTag("//Body",found);
	if(browser == "NS")
		node = node.iterateNext();
}

if (found==null || node == null)
  {
	  xmlResult=M_find(column,value,'next',index,kxyT,check,fmt,index);	
	  found=xmlResult;

  }
else
{
  xmlResult=found;
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	var msgcon=getTag("//Body/ConnId",xmlResult);
	var msgoffset=getTag("//Body/Offset",xmlResult);
	var xmlResult2=S_replace(msgcon,column,value,newvalue,msgoffset,fmt,kxyT,index);
        if (getTag(RETURNCODE,xmlResult2,browser)=="Success")
	{
		opener.selectFind(index,xmlResult,column,value,'replace',newvalue,fmt,kxyT);
		found=null;
		needtoUpdate=true;
		needtoApply=true;
		xmlResult=M_find(column,value,'next',index,kxyT,check,fmt,index);	
		found=xmlResult;
		
	}else
	{
	   opener.confDlgOpen = 1;
	   M_alert(getTag(EXPL,xmlResult2,browser),getTag(EXCEPTION,xmlResult2,browser),getTag(CCODE,xmlResult2,browser),getTag(RCODE,xmlResult2,browser));
 	   opener.confDlgOpen = 0;
 	}
 }else
  if(xmlResult != null)
  {
  	opener.confDlgOpen = 1;
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
	opener.confDlgOpen = 0;
   }
}
if (debug_On==true) logExit("M_replace",null);
}

needtoApply=false;
function M_apply(doapply,col,kxyT,index,fmt,all)
{
if (debug_On==true) logEnter("M_apply",null);

  var xmlResult=S_apply(doapply,col,kxyT,index,fmt);

  if (getTag(RETURNCODE,xmlResult,browser)!="Success")
  {
  	opener.confDlgOpen = 1;
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
	opener.confDlgOpen = 0;
	
	var temp = getTag("/Response/Body/PartialCompletion",xmlResult);

	if (temp && temp > 0)
	{
		var xmlResult2=opener.M_RefreshMsg() 
		if(all != null)
			opener.pendingMessages(6,xmlResult2);
		else
			opener.pendingMessages(5,xmlResult2);
	}
	needtoApply=false;

	if(doapply)
	{
		M_apply(false,col,kxyT,index,fmt,all);
		opener.findFlag = false;
		self.focus();
		setTimeout('opener.bringFocusFR()', 500);
	}
  }
  else
  {
  	if(doapply)
  	{
  		var temp = getTag("/Response/Header/Replaces",xmlResult);
  		if(temp > 0)
  		{
  			opener.needcommit=true;
  			needtoUpdate = true;
  		}
  		opener.confDlgOpen = 1;
  		M_alert("<font class='Attribute'><b>"+temp+"</b></font> replace(s) in <font class='Attribute'><b>"+getTag("/Response/Header/Completion",xmlResult)+"</b></font> message(s).");
		opener.confDlgOpen = 0;
	}
	if ((!doapply && getTag("/Response/Header/Completion",xmlResult) > 0) || needtoUpdate==true)
	{
		var xmlResult2=opener.M_RefreshMsg() 
		if(all != null)
			opener.pendingMessages(6,xmlResult2);
		else
			opener.pendingMessages(5,xmlResult2);
		needtoUpdate=false;
	}
	needtoApply=false;
	opener.findFlag = false;
	self.focus();
	setTimeout('opener.bringFocusFR()', 500);
  }
if (debug_On==true) logExit("M_apply",null);
}

function XMLtoStr(xmlnew)
{
var str;
var i;
if (xmlnew!=null){
  if (xmlnew.childNodes.length==0){
      if ((xmlnew.nodeType!=3)&&(!xmlnew.nodeValue))
  	return "<"+xmlnew.nodeName+">"+xmlnew.nodeValue+"</"+xmlnew.nodeName+">";
     else if (xmlnew.nodeValue!=null)
	return xmlnew.nodeValue;
       else return;
}
  else
 {
	str="<"+xmlnew.nodeName+">";
	for (i=0;i<xmlnew.childNodes.length;i++)
   	    str+=XMLtoStr(xmlnew.childNodes[i]);
        str+="</"+xmlnew.nodeName+">";	
	return str;
 }
}
}


function M_replaceAll(column,value,newvalue,index,kxyT,check,fmt)
{
if (debug_On==true) logEnter("M_replaceAll",["Column:"+column,"Value:"+value,"New value:"+newvalue]);
  var found=false;
  var toUpdate=[];
  var i=2;
  xmlResult=S_find(column,value,'first',kxyT,check,fmt,index,'all');
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	var msgcon=getTag("//Body/ConnId",xmlResult);
	var msgoffset=getTag("//Body/Offset",xmlResult);
	if (msgcon!=null)
	{
		var xmlResult2=S_replace(msgcon,column,value,newvalue,msgoffset,fmt,kxyT,index);
		found=true;
	}
 	else 
		found=false;
  }
  else
  if(xmlResult != null)
  {
  	opener.confDlgOpen = 1;
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));	  
 	opener.confDlgOpen = 0;
 }
  while (found==true)
  {
	xmlResult=S_find(column,value,'next',kxyT,check,fmt,index,'all');
	if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  	   if (getTag(XPATHCONNID,xmlResult)!=null)
	   {	  
		found=true;
		msgcon=getTag("//Body/ConnId",xmlResult);
		msgoffset=getTag("//Body/Offset",xmlResult);
		if (msgcon!=null)
			xmlResult2=S_replace(msgcon,column,value,newvalue,msgoffset,fmt,kxyT,index);
		else
			found=false;
 	   }else
		found=false;
	else
	if(xmlResult != null)
	{
		opener.confDlgOpen = 1;
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
		opener.confDlgOpen = 0;
	}
  }

  M_apply(true,column,kxyT,index,fmt,'all');
 
  opener.win.close();
  //win=null;

if (debug_On==true) logExit("M_replaceAll",null);
}


function replaceStr(value,offset,newvalue,oldvalue)
{
if (debug_On==true) logEnter("replaceStr",["Value:"+value,"Offset:"+offset,"New value:"+newvalue,"Old value:"+oldvalue]);

  var aux=value.substr(0,offset);
  var aux2=value.substr(aux.length+oldvalue.length,value.length);
  needtoUpdate=true;
if (debug_On==true) logExit("M_replaceStr",["String:"+aux+newvalue+aux2]);

return aux+newvalue+aux2;

/*  var aux=value.substr(0,offset-1);
  var aux2;
  if (value.length>offset+newvalue.length)
      
	aux2=value.substr(offset+value.length,value.length);
  else
	aux2="";*/

}

function M_getHeaderMetaData(type)
{
if (debug_On==true) logEnter("M_getHeaderMetaData",["Type:"+type]);
 var xmlResult=S_getHeaderMetaData(type);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	if (debug_On==true) logExit("M_getHeaderMetaData",null);
	return xmlResult;	
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_getHeaderMetaData",null);
return null;
}

//***********************************************************************************************************************
// Row Filters
//***********************************************************************************************************************

function M_displayFilter()
{
if (debug_On==true) logEnter("M_displayFilter",null);
  var xmlResult=M_listAvailFmt();
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	parent.ShowWindow('kxyFilt','','800px','650px',[handle,connid,xmlResult,url,uid]);
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_displayFilter",null);
}


function M_displayFilterMsg()
{
if (debug_On==true) logEnter("M_displayFilterMsg",null);
  var xmlResult=M_listAvailFmt();
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	fil=ShowWindow('kxyFilt','','800px','650px',[handle,connid,xmlResult,url,uid]);
		
  }else
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_displayFilterMsg",null);
}


function M_applyFilter(name)
{
  if (debug_On==true) logEnter("M_applyFilter",["Name:"+name]);
  var max;
  if(rtrim(ltrim(document.MessageForm.depthM.value)).length == 0)
 	max = maxMsg;
  else
 	max = document.MessageForm.depthM.value;
 
 
  var params=[max,'first',beginSequence,"<Filter>"+name+"</Filter>"]
  var tags=["Count","Mode","Cursor","RowDataFilter"];

  var xmlResult=S_peek(params,tags);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
  	current_peek = xmlResult;
  	document.MessageForm.gotoM.value = "";
	refreshTable(xmlResult);
   }else
   if(xmlResult != null)
	if(getTag(RETURNCODE,xmlResult,browser) != null)
	{
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
	}
	else
	{
		M_alert(err_278);
	}	
   if (debug_On==true) logExit("M_applyFilter",null);
}

function M_displaySave(fname,type,format,expression)
{
if (debug_On==true) logEnter("M_displaySave",["F name:"+fname,"Type:"+type,"Format:"+format,"Expression:"+expression]);
	var xmlResult = M_getFilters('','','','');
	if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
		var filt = xmlResult;
	else
		var filt = "";
 	ShowWindow('kxySvFil','','560px','500px',[type,format,expression,fname,url,browser,filt]);
if (debug_On==true) logExit("M_displaySave",null);
}

function M_saveFilter(name,type,format,expression,oldname,selector)
{
if (debug_On==true) logEnter("M_saveFilter",["Name:"+name,"Type:"+type,"Format:"+format,"Expression:"+expression,"Old name:"+oldname,"Selector:"+selector]);
var xmlResult;
  if (oldname!=name) 
   xmlResult=S_saveFilter(name,type,format,expression,selector);
  else
   xmlResult=S_updateFilter(name,type,format,expression,selector);

  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	M_alert(err_336);
	var xmlResult2=M_getFilters(name,type,format);
	var xmlNode=getXMLTag("//Filter/"+name,xmlResult2);
	if(browser == "NS")
		xmlNode = xmlNode.iterateNext();
	openF(xmlNode);
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_saveFilter",null);
}

function M_displayDel(type)
{
if (debug_On==true) logEnter("M_displayDel",null);
  if(type == 'variant')
  	var xmlResult=M_getVariants();
  else
  	var xmlResult=M_getFilters();
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	ShowWindow('kxyDelFi','','460px','470px',[xmlResult,type,uid,browser,getHandle(),getConnid(),url]);

  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_displayDel",null);
}


function M_delFilter(name)
{
if (debug_On==true) logEnter("M_delFilter",["Name:"+name]);
	var xmlResult=S_delFilter(name);
 	if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
 	{
 		if(browser == "NS")
 			window.opener.actionAfterCloseDialog("filter;"+name,'kxyDelFi');
 		else
 			window.returnValue = "filter;"+name;
 		window.close();
 	}else
 	if(xmlResult != null)
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_delFilter",null);
}


function M_displayGetFilters(fmts,type)
{
if (debug_On==true) logEnter("M_displayGetFilters",["Formats:"+fmts,"Type:"+type]);

var param = new Array();
param[0] = fmts;
param[1] = type;
param[2] = getHandle();
param[3] = getBackConnid();
param[4] = getBrowser();
param[5] = url;

result=ShowWindow('kxyGetFi','','600px','620px',param);
if (debug_On==true) logExit("M_displayGetFilters",null);
return result;
}

function M_getFilters(name,type,format,expression,selector,sysFmt)
{
if (debug_On==true) logEnter("M_getFilters",["Name:"+name,"Type:"+type,"Format:"+format,"Expression:"+expression]);
 var xmlResult=S_getFilters(name,type,format,expression,selector,sysFmt);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	if (debug_On==true) logExit("M_getFilters",null);
	return xmlResult;
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
  return xmlResult;
if (debug_On==true) logExit("M_getFilters",null);
}


function M_updateFilter(name,type,format,expression,selector)
{
if (debug_On==true) logEnter("M_updateFilter",["Name:"+name,"Type:"+type,"Format:"+format,"Expression:"+expression,"Selector:"+selector]);

  var xmlResult=S_updateFilter(name,type,format,expression,selector);
  if (xmlResult != null  && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	M_alert(err_338);
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_updateFilter",null);
}

function M_applyFiltersPeek(filt)
{
if (debug_On==true) logEnter("M_applyFiltersPeek",["Filters:"+filt]);

if(win != null)
	win.close();
	
loadingMessage("Loading...");
var useFilterFlag = "no";
var fi="";
var fic="";
var fih="";
var fich="";
var i=1;
var j,k;
var max;
if(rtrim(ltrim(document.MessageForm.depthM.value)).length == 0)
 	max = maxMsg;
else
 	max = document.MessageForm.depthM.value;
 
displayHeader = defaultHeader;
var params=[max,'','no',beginSequence];
var tags=["Count","Mode","UseFilter","Cursor"];
if (filt[0]!=0)
{
 for (i=1;i<=filt[0];i++)
	fi+="<Filter>"+filt[i]+"</Filter>";
 params[params.length]=fi;
 tags[tags.length]="RowDataFilter";
 useFilterFlag = "yes";
}


if (filt[i]!=0)
{
 for (j=i+1;j<=i+parseInt(filt[i]);j++)
	fic+="<Filter>"+filt[j]+"</Filter>";
 params[params.length]=fic; 
 tags[tags.length]="ColumnDataFilter";
 useFilterFlag = "yes";
}
else
	j =i+1;

if (filt[j]!=0)
{
 for (k=j+1;k<=j+parseInt(filt[j]);k++)
	fih+="<Filter>"+filt[k]+"</Filter>";
 params[params.length]=fih; 
 tags[tags.length]="RowHeaderFilter";
 useFilterFlag = "yes";
}
else
	k =j+1;
	
if (filt[k]!=0)
{
 for (j=k+1;j<=k+parseInt(filt[k]);j++)
	fich+="<Filter>"+filt[j]+"</Filter>";
 params[params.length]=fich; 
 tags[tags.length]="ColumnHeaderFilter";
 useFilterFlag = "yes";
  displayHeader = 'true';
}

params[2] = useFilterFlag;
  var xmlResult=S_peek(params,tags);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
  	current_peek = xmlResult;
  	document.MessageForm.gotoM.value = "";
  		
   	refreshTable(xmlResult);

   }else
   if(xmlResult != null)
   {
	if(getTag(RETURNCODE,xmlResult,browser) != null)
	{
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
		loadingMessage("Error retrieveing messages.");
		current_peek = null;
		resetPointerTable();
		document.getElementById('seqNumber').style.display="none";
	}
	else
	{
		M_alert(err_278);
	}
   }
if(displayHeader == "true")
	document.getElementById('showHeader').checked = true;
else
	document.getElementById('showHeader').checked = false;
	
appliedFilters=filt;

if (debug_On==true) logExit("M_applyFiltersPeek",null);
}

function M_displayApplyFilters()
{
if (debug_On==true) logEnter("M_displayApplyFilters",null);
var count_filter=0;
var rowFilter=[];
var rowFilterH=[];
var rowIndexH=0;
var rowIndex=0;
var colFilter=[];
var colIndex=0;
var colIndexH=0;
var colFilterH=[];

 var xml_result = M_getFilters();
   var count_filter = 0;
   if(xml_result != null){
	count_filter = count("//Filter",xml_result);
	if(count_filter != 0){
		if(browser == "NS")
			var nodeFilter = xml_result.childNodes[1].childNodes[3].childNodes[1].childNodes;//getXMLTag("//Body/Filter",xml_result);//xml_result.childNodes[1].childNodes;
		else
			var nodeFilter = xml_result.childNodes[1].childNodes[1].childNodes[0].childNodes;
	countFilter = nodeFilter.length;
	var n;
	if (browser=="NS")
		n=1;
	else
		n=0;
	for(i=0; i<countFilter;i++){
	   if(nodeFilter[i].nodeName != "#text"){
		if(getTag("//Body/Filter/*["+n+"]/@Type",xml_result)== "row"){
			if (getTag("//Body/Filter/*["+n+"]/@Selector",xml_result)== "data")
			{
				rowFilter[rowIndex] = nodeFilter[i].nodeName;
				rowIndex++;
			}else{
				rowFilterH[rowIndexH] = nodeFilter[i].nodeName;
				rowIndexH++;
			}
		}
		else{
			if (getTag("//Body/Filter/*["+n+"]/@Selector",xml_result)== "data")
			{
				colFilter[colIndex] = nodeFilter[i].nodeName;
				colIndex++;
			}else{
				colFilterH[colIndexH] = nodeFilter[i].nodeName;
				colIndexH++;
			}
		}
		n++;
	   }
	}
	}
   }

  result=ShowWindow('kxyappfi','','500px','515px',[rowFilter,colFilter,rowFilterH,colFilterH,appliedFilters,getBrowser()]);
if (debug_On==true) logExit("M_displayApplyFilters",null);
}

//********************************************************************************
// Variant Definitions
//********************************************************************************

function M_OpenVariantDefinitionDialog()
{	
	var xmlResult = M_listAvailFmt();
	if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
		ShowWindow('kxyVarDe','','570px','630px',[xmlResult,getBrowser(),getHandle(),getBackConnid(),url,uid]);
	else
	if(xmlResult != null)
		M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
}



function M_addVariant(name,filter,message_format,real_format,oldname)
{
if (debug_On==true) logEnter("M_addVariant",["Name:"+name,"Filter:"+filter,"Message Format:"+message_format,"Real Format:"+real_format,"Old name:"+oldname]);
var xmlResult;
  if (oldname!=name)
   xmlResult=S_addVariant(name,filter,message_format,real_format);
  else
   xmlResult=S_updateVariant(name,filter,message_format,real_format);

  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
  	if (oldname!=name)
  		M_alert(err_339);
  	else
  		M_alert(err_340);
	var xmlResult2=M_getVariants(name,filter,message_format,real_format);
	var xmlNode=getXMLTag("//Variant/"+name,xmlResult2);
	if(browser == "NS")
		xmlNode = xmlNode.iterateNext();
	openVariant(xmlNode,1);
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_addVariant",null);
}


function M_getVariants(name,filter,message_format,real_format,owner)
{
if (debug_On==true) logEnter("M_getVariants",["Name:"+name,"Filter:"+filter,"Message Format:"+message_format,"Real Format:"+real_format,"Owner:"+owner]);
  var xmlResult=S_getVariants(name,filter,message_format,real_format,owner);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	if (debug_On==true) logExit("M_getVariants",null);
	return xmlResult;
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_getVariants",null);
}


function M_deleteVariant(name)
{
if (debug_On==true) logEnter("M_deleteVariant",["Name:"+name]);
  var xmlResult=S_deleteVariant(name);
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
 	if(browser == "NS")
 		window.opener.actionAfterCloseDialog("variant;"+name,'kxyDelFi');
 	else
 		window.returnValue = "variant;"+name;
 	window.close();
  }else
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_deleteVariant",null);
}


//********************************************************************************
// Column Filters
//********************************************************************************

function M_displayColumnFilter()
{
if (debug_On==true) logEnter("M_displayColumnFilter",null);
  var xmlResult=M_listAvailFmt();
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	ShowWindow('kxyColFi','','690px','450px',[handle,connid,xmlResult,getBrowser(),url,uid]);
  }else
  if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_displayColumnFilter",null);
}


//********************************************************************************
// Auxiliary functions
//********************************************************************************


function M_getQueueOptions(queueName)
// returns an xml with the options to open a queue
{
if (debug_On==true) logEnter("M_getQueueOptions",["Queue Name: "+queueName]);
if (debug_On==true) logExit("M_getQueueOptions",null);
	if(QType == TYPEMQ)
		var returnVal = getXMLTag("//"+QType+"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name=\""+queueName+"\"]",userProfile);
	else
	{	var countQ = count("//"+QType+"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue",userProfile);
		for(var i = 0; i < countQ;i++)
		{
			if(browser == "NS")
				var d = i+1;
			else
				var d = i;
			var node = getXMLTag("//"+QType+"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue["+d+"]/Name",userProfile);
			if(browser == "NS")
				node = node.iterateNext();
				if(node.firstChild.nodeValue == queueName)
				{
					var returnVal = getXMLTag("//"+QType+"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue["+d+"]",userProfile);
					break;
				}
		}
	}
	if(browser == "NS")
		returnVal = returnVal.iterateNext();
  	return returnVal;
  
}

function M_putQueueOptions(array_options)
{
if (debug_On==true) logEnter("M_putQueueOptions",["Array options:"+array_options]);
  var xmlResult;
  var queueName = checkSpecialChars(array_options[0]);
  queueName = checkBackSlash(queueName);
  if(QType == TYPEMQ)
  	var userQueue = count("//"+QType+"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name=\""+queueName+"\"]",userProfile);
  else
    	var userQueue = count("//"+QType+"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name=\"<![CDATA["+queueName+"]]>\"]",userProfile);
 
 
  if (userQueue == 0)
   {
	xmlResult=S_addQueueProfile(array_options);
   }
  else
   {
       xmlResult=S_updateQueueProfile(array_options); 
    }
  if (xmlResult != null && getTag(RETURNCODE,xmlResult,browser)=="Success")
  {
	if (debug_On==true) logExit("M_putQueueOptions",null);
	return xmlResult;
  }
  else
    if(xmlResult != null)
	M_alert(getTag(EXPL,xmlResult,browser),getTag(EXCEPTION,xmlResult,browser),getTag(CCODE,xmlResult,browser),getTag(RCODE,xmlResult,browser));
if (debug_On==true) logExit("M_putQueueOptions",null);
}


function getQType()
{
if (debug_On==true) logEnter("getQType",null);
if (debug_On==true) logExit("getQType",null);
return QType;
}

function getBrowser()
{
if (debug_On==true) logEnter("getBrowser",null);
if (debug_On==true) logExit("getBrowser",null);
 return browser;}

function setBrowser(br)
{
if (debug_On==true) logEnter("setBrowser",null);
if (debug_On==true) logExit("setBrowser",null);
  browser=br;
}

function getActiveQmgr()
{
if (debug_On==true) logEnter("getActiveQmgr",null);
if (debug_On==true) logExit("getActiveQmgr",null);
 return ActiveQmgr;}

function getQueueName()
{
if (debug_On==true) logEnter("getQueueName",null);
if (debug_On==true) logExit("getQueueName",null);
 return Qopen;}

function M_qmgr()
{
if (debug_On==true) logEnter("M_qmgr",null);
   return S_listResources(QType);
}

function M_alert(msgstr,str,ccode,rcode,noShowAgain,win)
{
if (debug_On==true) logEnter("M_alert",["Message:"+msgstr,"String:"+str,"Completion Code:"+ccode]);

var errorMsg = "TIMEOUT";
if (ccode==KXY_ERR_SESSION_CLOSED||ccode==KXY_ERR_IDLE || ccode==KXY_ERR_SECURITY)
{
	if(ccode==KXY_ERR_SESSION_CLOSED || ccode==KXY_ERR_SECURITY)
	{
		timeOut = 2;
		errorMsg = "INVALID_SESSION";
		M_alert(err_352);
	}
	else
	{
		timeOut = 1;
		M_alert(err_342);
	}

	if(parent.frame0 != null)
	{
		if(ccode==KXY_ERR_SESSION_CLOSED || ccode==KXY_ERR_SECURITY)
			initializeLogout();
		else
			initializeTimeOut();
	}
	else
	{
		if (win)
			win.close();	
		
		if (debugwin!=null)
			debugwin.close();
		
		if(opener && (opener.dialogName == "kxyFind" || opener.dialogName == "kxyRepl"))
			window.opener.actionAfterCloseDialog(errorMsg);
		else
		{
			window.returnValue = errorMsg;
		}
		window.close();
		windowClose = 1;	
	}
	
}
else{
	var len = 150;
	if(str !=null && str != "")
		len += rtrim(ltrim(str+"")).length  + 20;
	if(msgstr !=null && msgstr != "")
		len += rtrim(ltrim(msgstr+"")).length +20;
	if(ccode !=null && ccode != "")
		len += rtrim(ltrim(ccode+"")).length +20;
	if(rcode !=null && rcode != "")
		len += rtrim(ltrim(rcode+"")).length +20;
	if(noShowAgain !=null && noShowAgain != "")
		len += rtrim(ltrim(noShowAgain+"")).length +20;
	if(win !=null && win != "")
		len += rtrim(ltrim(win+"")).length +20;
		
	var heightW = len;
	len += "px";	

	ShowWindow("kxyalert",'','400px',len,[msgstr,str,ccode,rcode,noShowAgain,win,heightW]);
}


if (debug_On==true) logExit("M_alert",null);
}

function M_stoperror()
{
  return true;
}



function validateFormNames(val,name){
var tempName = rtrim(ltrim(val));
var valid = 1;
for(var a = 0; a <tempName.length;a++){
	var temp = tempName.charAt(a);
	if(name == "host")
		var not_allowed = "~`!@#$^&*()\\\"'+=|{}[],:;<>?";
	else
		var not_allowed = "~`!@#$^&*()\\-\"'+=|{}[],:;<>?";
	if(!isValid(temp,not_allowed)){
		valid = 0;
		break;
	}
}
if(valid == 0)
{
	if(name == "host")
		M_alert(err_018);
	else
		M_alert("A "+name+ " "+ err_013);
}
return valid;

}