/*
#$Id: kxydebug.js,v 1.6 2003/10/01 02:15:41 rbais Exp $#
######################################################################
# Copyright 1999-2003, Candle Corporation, a California corporation.  
# All rights reserved. International copyright secured.
#
# This material is proprietary to Candle Corporation and is not to be
# reproduced, used, or disclosed except in accordance with program
# licenses or upon written authorization of Candle Corporation.
#
#######################################################################*/
// variable with the log text

var debug_r=0;
var debug_request=[];
var debug_resp=[];
var debug_p=0;
var debug_On=false;

var debugwin=null;


//********************************************************************************
// Debugger
//********************************************************************************

function M_debugger()
{
if (debugwin==null)
{
	debugwin=window.open("kxydebug.htm","","top=100,left=300,toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,copyhistory=no,width=700px,height=500px");
	debugwin.dialogArguments = [debug_html,debug_r,debug_request,debug_resp,debug_p];
	windowOpen=1;
}
else
	debugwin.focus();
}

function debug_setparams(par)
{
 var aux=par[par.length-1];
 debug_html=aux[0];
 debug_request=aux[1];
 debug_resp=aux[2];
 debug_r=aux[3];
 debug_p=aux[4];
}

//*********************************************************************
// functions to keep track
//*********************************************************************

function logEnter(fname,params)
// this function takes note of the function that we are executing
{
var i;
var debug_htmlaux;
  debug_htmlaux="<div><table><tr><td colspan=2><font class=dark>Executing function "+fname+"</font></td></tr>";
  if (params!=null)
	  debug_htmlaux=debug_htmlaux+ "<tr><td width=10><img src='images/white.gif'></td><td><font>"+params[0]+"</font></td></tr>";
  if (params!=null)
	  for (i=1;i<params.length;i++)
		debug_htmlaux=debug_htmlaux+"<tr><td width=10><img src='images/white.gif'></td><td><font>"+params[i]+"</font></td></tr>";

debug_htmlaux=debug_htmlaux+"</table></div>"; 
 if (windowOpen==1)
	addEntry(debug_htmlaux);
  debug_html=debug_html+debug_htmlaux;
  return debug_html;
}

function logExit(fname,params)
// this function takes note of the function that we are exiting
{
var debug_htmlaux;
var i;
  debug_htmlaux="<div><table><tr><td colspan=2><font class=dark>Exiting function "+fname+"</font></td></tr>";
  if (params!=null)
 	  debug_htmlaux=debug_htmlaux+ "<tr><td><img src='images/white.gif'></td><td><font>"+params[0]+"</font></td></tr>";
  if (params!=null)
	  for (i=1;i<params.length;i++)
		debug_htmlaux=debug_htmlaux+"<tr><td style='width:10px'></td><td><font>"+params[i]+"</font></td></tr>";
debug_htmlaux=debug_htmlaux+"</table></div>";
  if (windowOpen==1)
	addEntry(debug_htmlaux);
  debug_html=debug_html+debug_htmlaux;
  return debug_html;
}

function logReq(reqname,req)
// this function takes note of the request sent to the backend
{
var debug_htmlaux;
  debug_htmlaux="<div><table><tr><td><img src='images/white.gif'></td><td><font><i>request: "+reqname+"</i></font></td></tr>";
  debug_htmlaux=debug_htmlaux+ "<tr><td style='width:10px'><img src='images/white.gif'></td><td width:100px><font id='req_"+debug_r+"'>"+generateReqTable(req)+"</font></td></tr>";
  if (debug_request==null)
	debug_request=[];
  debug_request[debug_r]=req;
  debug_r++;
debug_htmlaux=debug_htmlaux+"</table></div>";
  if (windowOpen==1)
	addEntry(debug_htmlaux);
  debug_html=debug_html+debug_htmlaux;
  return debug_html;
}

function logResp(response)
// this function takes note of the response recieved from the backend
{
var debug_htmlaux;
  debug_htmlaux="<div><table><tr><td><img src='images/white.gif'></td><td><font><i>response:</i></font></td></tr>";
  debug_htmlaux=debug_htmlaux+ "<tr><td><img src='images/white.gif'></td><td><font id='resp_"+debug_p+"'>"+generateReqTable(response.xml)+"</font></td></tr>";
  if (debug_resp==null)
	debug_resp=[];
  debug_resp[debug_p]=response.xml;
  debug_p++;
debug_htmlaux=debug_htmlaux+"</table></div>";
  if (windowOpen==1)
	addEntry(debug_htmlaux);
  debug_html=debug_html+debug_htmlaux;
  return debug_html;
}

function generateReqTable(req)
{
var t="<table border=0 cellpadding=0>";
var endstr=0;
var pos=0;
var aux=req; 
var newreq=null;
while (aux.indexOf("<")!=-1)
 {
	aux2= aux.replace("<","&lt;");
	aux=aux2;
 }
while (aux.indexOf(">")!=-1)
 {
	aux2= aux.replace(">","&gt;");
	aux=aux2;
 }
newreq=aux;

while (endstr==0)
{
  aux=newreq.substr(pos,pos+100);
  t=t+"<tr><td><img src='images/white.gif'></td><td><font>"+aux+"</font></td></tr>";
  pos=pos+100;
  if (pos>=req.length)
	endstr=1;
  aux=null;
}
t=t+"</table>";
return t;
}

//**********************************************************************
// function to manipulate the window
//**********************************************************************

function addEntry(newRow)
// displays the new entry in the debugger window
{

if (debugwin!=null)
{
var table=debugwin.document.getElementById("log");
if (table!=null)
		insertAdjHTML(table,"beforeEnd",newRow);
//else
	//M_alert(err_320);
}
}

// simple log output
function debugTime(pos,time)
{
    addEntry("<div><table><tr><td>" + pos + ": " + time + "</td></tr></table></div>");
}

function insertAdjHTML(texta,pos,html)
{
  if (getBrowser()=="NS")
  {
	if (pos=='afterEnd')
	{
		var range = document.createRange();
		range.setStartAfter(texta.lastChild);
		var docFrag = range.createContextualFragment(html);
		texta.appendChild(docFrag);
	}else if (pos=='afterBegin')
	{
		var range = document.createRange();
		range.setStartBefore(texta.firstChild);
		var docFrag = range.createContextualFragment(html);
   		texta.insertBefore(docFrag,texta.firstChild);
	}else if (pos=='beforeEnd')
	{
		var range = document.createRange();
		range.setStartAfter(texta.lastChild);
		var docFrag = range.createContextualFragment(html);
   		texta.appendChild(docFrag);
	}else if (pos=="beforeBegin")
	{
		var range = document.createRange();
		range.setStartBefore(texta.parentNode);
		var docFrag = range.createContextualFragment(html);
   		texta.parentNode.insertBefore(docFrag,texta);
	}
  }else
	texta.insertAdjacentHTML(pos,html);
}

